"
    Welcome to ObjectShare Distributed Smalltalk for VSE    Release date: Dec. 30, 1996
        (c)  Copyright  1996-1999 ObjectShare, Inc.
        (c)  Copyright  1993-1995 Hewlett-Packard Company.
        All rights reserved.

--------------------------------------------------------------------------------------------------------------------------------------------------------------------
    DST for VSE is provided as a custom service and is not supported via the normal ObjectShare support 
    channels.  Please consult your individual purchase agreement for terms of support.
--------------------------------------------------------------------------------------------------------------------------------------------------------------------


--------------------------------------------------------------------------------------------------------------------------------------------------------------------
     I.  Getting Started
--------------------------------------------------------------------------------------------------------------------------------------------------------------------

The DST Console can be opened by evaluating the expression below:
"
                            DSTConsole new open.
"
Use the File->Settings->Repository menu to open a dialog for configuring the ORB to access the VW image that 
will be supplying the interface repository for this image. In that dialog, either click the 'hostname' button and supply 
the hostname and port number, or click 'filename' and supply the name of a file containing a 'stringified object 
reference' to the VW image's ORB daemon.

You can then click the 'Start' button on the console to start the local ORB.  Once the ORB is running it may 
communicate with other ORB's.  Following is a collection of useful expressions.  Unless otherwise noted, the
xpressions are valid in both a VSE DST and a VW DST image.

--------------------------------------------------------------------------------------------------------------------------------------------------------------------
     II.  Examples
--------------------------------------------------------------------------------------------------------------------------------------------------------------------

        A.  Frequently used.

            1.  Getting a newly minted universally unique identifier.
"
                    ORBObject newId.
"
        B.  Configuration

            1. Generating stringified object references to the critical objects of a DST image.
" 
                    ORBObject referenceToFile: 'ORBObject.ref' object: ORBObject.
                    ORBObject referenceToFile: 'ORBDaemon.ref' object: ORBObject daemon.
                    ORBObject referenceToFile: 'FactoryFinder.ref' object: ORBObject factoryFinder.
                    ORBObject referenceToFile: 'NamingService.ref' object: ORBObject namingService.
"
            2.  Reading in a stringified object reference.
"
                    remoteORBDaemon := ORBObject referenceFromFile: 'remoteORBDaemon.ref'.
"
            3.  Programmatically generating an object reference to another VSE or VW DST image's ORBObject 
                 class.
"
                    remoteOrbProxy := OrbResolver generateOrbProxy: 'someDNSName'.
                    remoteOrbProxy := OrbResolver generateOrbProxy: '123.123.123.123'.
"
            4.  Programmatically setting the transport protocol.
"
                   ORBDaemon configurationManager chooseTransportNamed: #IIOP.
"
            5.  Programmatically configuring the Interface Repository using a file containing a stringified object 
                 reference.
"
                    ((ORBDaemon configurationManager allServices) at: #interfaceRepository) 
                            setFilename: 'remoteORBDaemon.ref'.
"
            6.  Programmatically configuring the Interface Repository using hostname, transport ID, and port 
                 number.
"
                    ((ORBDaemon configurationManager allServices) at: #interfaceRepository)
                                            setHostname: 'remoteHostName'
                                            transport: #IIOP
                                            port: 3460.
"
            7.  Programmatically configuring the image to employ a remote Naming Service, using a stringified
                 object reference.
"
                    ((ORBDaemon configurationManager allServices) at: #namingService)
                            setFilename: 'remoteNamingService.ref'.
"
            8.  Programmatically configuring the image to employ a remote Naming Service, using hostname, 
                 transport ID, and port number.
"
                    ((ORBDaemon configurationManager allServices) at: #namingService)
                                            setHostname: 'remoteHostName'
                                            transport: #IIOP
                                            port: 3460.
"
            9.  Programmatically initializing the Factory Finder.
"
                    ORBObject initializeFactories.


        C.  ORB Initialization, Startup, and Shutdown

            1.  Programmaticallay accessing hostname and port number.
"
                    hostname := SocketAccessor getHostname.
                    nodeId := IPSocketAddress hostAddressByName: hostname.
"
            2.  Programmatically initializing the ORB.
"
                    ORBObject initializeORBAtHost: hostname nodeID: nodeId.
"
            3.  Progammatically starting the ORB.
"
                    ORBDaemon startUpCoordinator startRequestBroker.
"
            4.  Programmatically stopping the ORB.
"
                    ORBDaemon startUpCoordinator shutDownRequestBroker.
"
        D.  Initial Communication with a Remote ORB.

            1.  All the principal ways of getting a remote ORB Proxy in a DST environment.
"
                    remoteOrbProxy := ORBObject referenceFromFile: 'remoteORBObject.ref'.
                    remoteOrbProxy := (ORBObject referenceFromFile: 'remoteORBDaemon.ref') orbObject.
                    remoteOrbProxy := OrbResolver generateOrbProxy: '123.123.123.123'.
                    remoteOrbProxy := OrbResolver generateOrbProxy: 'someHostName'.
"
            2.  Accessing a list of the services provided by a remote ORB.  The variable 'initialServices' will
                 contain an OrderedCollection of service keys, like 'NameService' and 'FactoryFinder'.
"
                    initialServices := remoteOrbProxy listInitialServices.
"
            3.  Accessing a remote naming service in several ways.
"
                    remoteNamingService := ORBObject referenceFromFile: 'remoteNamingService.ref'.
                    remoteNamingService := remoteOrbProxy namingService.                  
                    remoteNamingService := (initialServices includes: 'NameService')
                                                            ifTrue: [ remoteOrbProxy resolveInitialReferences: 'NameService' ]
                                                            ifFalse: [ nil ].
"
            4.  Accessing a remote FactoryFinder in several ways.
"
                    remoteFactoryFinder := ORBObject referenceFromFile: 'remoteFactoryFinder.ref'.
                    remoteFactoryFinder := (initialServices includes: 'FactoryFinder')
                                                            ifTrue: [ remoteOrbProxy resolveInitialReferences: 'FactoryFinder' ]
                                                            ifFalse: [ nil ].


