"3.1.1.0"
!  

CPSubPane subclass: #CPBitmapButton
  instanceVariableNames: 
    ' title picture onPicture pressed '
  classVariableNames: ''
  poolDictionaries: 
    ' CharacterConstants OperatingSystemConstants '!   

CPBitmapButton subclass: #CPBitmapToggle
  instanceVariableNames: 
    ' value '
  classVariableNames: ''
  poolDictionaries: 
    ' OperatingSystemConstants '!   

CPBitmapToggle subclass: #CPHorizontalPictureButton
  instanceVariableNames: 
    ' pictureHit onPictureHit highlighted '
  classVariableNames: ''
  poolDictionaries: 
    ' CPSystemBitmaps OperatingSystemConstants '!  

CPHorizontalPictureButton subclass: #CP3DRadioButton
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: 
    ' CPSystemBitmaps OperatingSystemConstants '!

CPHorizontalPictureButton subclass: #CP3DCheckBox
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: 
    ' CPSystemBitmaps '!

!CPBitmapButton methods !   
isPushButton
        "Answer whether the receiver is an instance of a push button"
    ^true
! !

!CPBitmapButton methods !  
contents
    "Answer the label of the reciever"

    ^title! !

!CP3DRadioButton methods !   
validate
    "Private"

    super validate.
    self selection
        ifTrue:
            [self turnOffSiblings.
            ].! !

!CPBitmapButton methods !   
defaultDroppedOn: aDragDropList
    "Accept the drag and drop."

    #obsoleteMethod.
    aDragDropList items notEmpty
        ifTrue:
            [aDragDropList items
                do:
                    [:item |
                    item isBitmap
                        ifTrue: [self bitmap: item]
                        ifFalse: [
                            (self isCompatible: item)
                                ifTrue: [self contents: item]]].
            self display]! !

!CPHorizontalPictureButton methods !   
drawFocusRectColor: ignored
    "Private"

    | stringOrigin |
    title isNil
        ifTrue:
            [self drawFocusRect: self rect.
            ]
        ifFalse:
            [stringOrigin := self rect leftTop + ((self pictureWidth + self space) @ (self height - self font height // 2)).
            self drawFocusRect: ((stringOrigin extent: (self font stringExtent: title)) expandBy: 1).
            ].! !

!CPBitmapButton methods !   
gettingFocus
    "Private"

    self drawFocusRect.
    super gettingFocus.! !

!CPBitmapButton methods !   
button1DoubleClick: point
    "Private"

    self disabled ifFalse: [self button1Down: point].! !

!CPHorizontalPictureButton methods !  
displayPicture: pen
inRect: inRect
    "Private"

    picture isNil
        ifTrue: [^self].
    value
        ifTrue:
            [onPicture displayAt: inRect left @ (self height - onPicture height // 2 + inRect top) with: pen.
            ]
        ifFalse:
            [picture displayAt: inRect left @ (self height - picture height // 2 + inRect top) with: pen.
            ].! !

!CPBitmapButton methods !  
defaultFont
    "Private - Answer the default font for the control."

    ^ButtonFont! !

!CP3DRadioButton methods ! 
wmLbuttondown: wParam
with: longInteger
	"Private - Process left button down message."

	| answer |
	self propertyAt: #ignoreSetFocus put: true.
	answer :=  super wmLbuttondown: wParam with: longInteger.
	self propertyAt: #ignoreSetFocus put: nil.
	^answer
! !

!CPBitmapButton methods !
highlight
    "Private"

    | holdPicture |
    self doGraphics: 
        [self pen
            draw3DRect: self rectToHighlight
            depth: 2
            style: #in.
        ].
    onPicture isNil
        ifFalse:
            [holdPicture := picture.
            picture := onPicture.
            self
                invalidateRect: (self rect insetBy: 3);
                updateWindow.
            picture := holdPicture.
            ].! !

!CPBitmapButton methods ! 
drawFocusRect
    "Private"

    self drawFocusRectColor: Color darkGray.! !

!CPBitmapButton methods !  
receiveAllWindowMessages
    "Private - Do Nothing"! !

!CPBitmapButton methods !  
losingFocus
    "Private"

    self drawFocusRectColor: self backColor.
    super losingFocus.! !

!CP3DRadioButton methods !   
turnOff
    "Private"

    super selection: false.! !

!CPHorizontalPictureButton methods !  
unHighlight
    "Private"

    highlighted := false.
    self doGraphics: [self displayPicture: self pen inRect: self rect].! !

!CPHorizontalPictureButton methods !   
pictureWidth
    "Private"

    picture notNil
        ifTrue: [^picture width].
    ^0! !

!CPBitmapToggle class methods !
constructEventsTriggered
    "Private - answer the set of events that instances of the
        receiver can trigger."

    ^super
        constructEventsTriggered remove: #clicked;
        add: #clicked:;
        yourself! !

!CPBitmapButton methods !  
keyboardInput: aKeyboardInputEvent
        "Private - keyboard input was received."
    ( aKeyboardInputEvent character == Cr
        and: [ self isPushButton
        and: [ self mainWindow isDialogTopPane not ]] )
        ifTrue: [ ^self "handled by keyDownInput: and keyUpInput:" ].
    ^super keyboardInput: aKeyboardInputEvent! !

!CPBitmapButton methods !  
getMnemonicHandler: char
        "Private - Check if this control handles this mnemonic.
        Answer the receiver if it does, else nil."
    | index |
    ( title isNil or: [ self disabled ] ) ifTrue: [ ^nil ].
    ^( ( index := ( title indexOf: '\u' replaceEscapeCharacters first ) ) ~= 0
        and: [ ( title at: index + 1 ) asLowerCase == char asLowerCase ] )
        ifTrue: [ self ]
        ifFalse: [ nil ]! !

!CPBitmapButton methods ! 
dragTargetDropDefault: dragSession
        "Private - provide default handling of drop if no handler
        is provided by inserting the item into the list."
	super dragTargetDropDefault: dragSession.
	(self dragTargetFormats includes: 'bitmap') ifTrue: [
		dragSession objects do: [ :each |
			each hasBitmap ifTrue: [
				self bitmap: each bitmap.
				^self ] ] ].
	^nil! !

!CPBitmapButton methods !
wmUser99: wparam
with: lparam
    "Private"

    self
        press;
        releaseButton.
    ^nil! !

!CPBitmapButton methods !   
defaultBitmap
	 "Answer the default 'off' button bitmap."

    ^nil! !

!CPBitmapToggle methods !
unHighlight
    "Private"

    self doGraphics: 
        [self pen
            draw3DRect: self rectToHighlight
            depth: 2
            style: #out.
        ].! !

!CPBitmapButton methods !  
dragSourceNeedsObjectDefault: dragSession
        "Private - provide default for requested drag items if no handler
        is provided by supplying the currently selected item."
	self contents ifNil: [ ^self ].
	super dragSourceNeedsObjectDefault: dragSession.
	self bitmap notNil ifTrue: [
		dragSession objects first bitmap: self bitmap ].! !

!CP3DRadioButton methods ! 
turnOffSiblings
    "Private"

    self tabGroupMembers do: [ :aPane |
        ( aPane ~= self and: [ aPane isRadioButton ] )
            ifTrue: [ aPane turnOff ] ].! !

!CPHorizontalPictureButton methods !
drawFocusRect
    "Private"

    self drawFocusRectColor: Color darkGray.! !

!CPBitmapButton methods !  
cancelPushButton
    "Set the style to a cancel button"

    self propertyAt: #cpStyle put: #cancelPushButton! !

!CPBitmapButton methods !  
onBitmap: aBitmap
    "Set the bitmap displayed in the reciever
     when the button is pressed"

    onPicture := aBitmap.! !

!CPBitmapButton methods !   
pushIt
    "Private"

    self
        setFocus;
        press;
        releaseButton.! !

!CPHorizontalPictureButton methods !   
focusRect
	"Private - Answer the focus rectangle. 
	(Stolen from CPHorizontalPictureButton>>drawFocusRectColor:)"

	| stringOrigin |
	stringOrigin := (self rect left + self pictureWidth + self space) @ (self rect bottom + (self height - self font height // 2)).
	^(Rectangle leftBottom: stringOrigin extent: (self font stringExtent: title)) expandBy: (2 @ 1)! !

!CPHorizontalPictureButton methods !   
releaseButton
    "Private"

    pressed := false.
    self unHighlight.
    value := value not.
    self
        doGraphics:
            [self displayPicture: self pen inRect: self rect.
            ].
    self triggerEvents! !

!CPBitmapButton methods !   
contents: anObject
    "Set the label of the reciever"
    "Ignore bitmaps sent by CPSubPane>>dragTargetDropDefault:"
    anObject isBitmap ifTrue: [^self].
    anObject isNil ifTrue: [^title := nil].
    [title := anObject asString] on: Error do: [^self].
    title = '' ifTrue: [title := nil].! !

!CPBitmapToggle methods ! 
triggerEvents
    "Private"

    self event: #clicked. " OBSOLETE "
    self triggerEvent: #clicked: with: value! !

!CP3DCheckBox methods !
defaultOnBitmap
	"Answer the default bitmap displayed while the button
	 is being pressed: the 'on' bitmap."

    ^CPCheckBoxOnWhiteCheckSysBitmap! !

!CPHorizontalPictureButton class methods !   
defaultBackColor
    "Private - Answer the default background color 
         for the receiver."

    ^Color windowBackground! !

!CPBitmapButton methods ! 
keyUpInput: aKeyboardInputEvent
        "Private - key up event was received."

    pressed ifTrue: [
        self releaseButton.
        ^self ].
    ^super keyUpInput: aKeyboardInputEvent! !

!CPBitmapButton methods !   
keyDownInput: aKeyboardInputEvent
        "Private - key down event was received."
    | ch |
    pressed ifFalse: [
        ch := aKeyboardInputEvent character.
        (ch = Cr) ifTrue: [
            self isPushButton ifFalse: [
                (self mainWindow defaultPushButton notNil
                    and: [ self mainWindow isDialogTopPane not ])
                        ifTrue: [ ^self ] ] ].
        (ch = Cr) | (ch = Space) ifTrue: [
            self press.
            ^self ] ].
    ^super keyDownInput: aKeyboardInputEvent! !

!CPBitmapButton methods ! 
bitmap
	 "Answer the 'off' button bitmap."

    ^picture! !

!CPBitmapButton methods !   
wmGettext: wparam
with: lparam
    "Private"

    | address string struct |
    address := ExternalAddress
        new highHalf: (lparam // 65536);
        lowHalf: (lparam \\ 65536);
        yourself.
    self contents notNil
        ifTrue:
            [string := self contents copyFrom: 1 to: (wparam min: self contents size + 1) - 1.
            ]
        ifFalse:
            [string := ''].
    struct := ExternalBuffer new: wparam.
    struct contents: string asAsciiZ.
    struct copyToAddress: address.
    ^string size! !

!CPBitmapButton methods !
defaultOnBitmap
	"Answer the default bitmap displayed while the button
	 is being pressed: the 'on' bitmap."

    ^nil! !

!CPBitmapButton methods !
defaultPushButton
    "Set the style to a default button"

    self propertyAt: #cpStyle put: #defaultPushButton! !

!CP3DRadioButton methods !  
isRadioButton
    "Private"

    ^true! !

!CPBitmapButton methods ! 
unHighlight
    "Private"

    self doGraphics: 
        [self pen
            draw3DRect: self rectToHighlight
            depth: 2
            style: #out.
        ].
    onPicture isNil
        ifFalse:
            [self
                invalidateRect: (self rect insetBy: 3);
                updateWindow.
            ].! !

!CPBitmapToggle methods !
selection: aBoolean
    "Set the selection of the reciever"

    value = aBoolean
        ifTrue: [^self].
    value := aBoolean.
    self isHandleOk & self pen notNil
        ifFalse: [^self].
    self hasFocus
        ifTrue:
            [self display.
            ]
        ifFalse:
            [self doGraphics: [self display].
            ].! !

!CPBitmapButton methods !  
bitmap: aBitmap
    "Set the bitmap displayed in the reciever"

    picture := aBitmap.! !

!CP3DCheckBox methods !  
defaultBitmap
	 "Answer the default 'off' button bitmap."

    ^CPCheckBoxSysBitmap
! !

!CPBitmapButton methods !  
validate
    "Private - The host window for the receiver was
     just created or recreated."

    self cpStyle == #defaultPushButton
        ifTrue: [self mainWindow defaultPushButton: self].
    self cpStyle == #cancelPushButton
        ifTrue: [self mainWindow cancelPushButton: self].
    super validate! !

!CPHorizontalPictureButton methods !
displayWith: pen
inRect: inRect
clipRect: clipRect
    "Private"

    | stringOrigin |
    (self backColor = self defaultBackColor) & parent notNil
        ifTrue:
            [pen fill: inRect color: parent backColor.
            ]
        ifFalse:
            [pen fill: inRect color: self backColor.
            ].
    title notNil
        ifTrue:
            [stringOrigin := (inRect left + self pictureWidth + self space) @ (inRect top + (self height - self font height // 2)).
            pen
                setTextAlign: TaTop;
                foreColor: self foreColor;
                backColor: self backColor;
                setBackMode: Transparent;
                winDrawText: title at: stringOrigin.
            ].
    self displayPicture: pen inRect: inRect.
    self hasFocus
        ifTrue:
            [self drawFocusRect.
            ].! !

!CP3DRadioButton methods !
initialize
	"Private"

	super initialize.
	picture := self defaultBitmap.
	onPicture := self defaultOnBitmap.! !

!CPBitmapButton methods !
isCompatible: anObject
    "Is <anObject> compatible with the receiver"

	#obsoleteMethod.
    ^anObject respondsTo: #asString! !

!CP3DRadioButton methods !   
gettingFocus
	"Private"

	super gettingFocus.! !

!CPBitmapButton methods !  
defaultDragDropObjects
    "Answer the list of items that should be
     passed during drag-drop"

    | dragObjects |
    #obsoleteMethod.
    (dragObjects := self getDefaultDragObjects) notNil
        ifTrue: [^dragObjects].
    dragObjects := Array with: self contents with: self bitmap.
    self renderAsObjects
        ifFalse:
            [dragObjects := dragObjects
                collect:
                    [:each |
                    each asString]].
    ^dragObjects! !

!CPBitmapButton methods !   
mnemonic: char typedIn: aPane
        "The receiver's mnemonic was typed in the
		sibling <aPane>.  Perform a programmatic button click."
	pressed ifFalse: [
		self sendInputEvent: #press.
		self setFocus].! !

!CPBitmapButton methods !   
characterInput: aChar
    "Private"

    ( self superWindow altKeyInput: aChar from: self )
        ifTrue: [ ^self ].  "character handled"
    ^super characterInput: aChar! !

!CPBitmapButton methods ! 
triggerEvents
    "Private"

    self event: #clicked. " OBSOLETE "
    self triggerEvent: #clicked! !

!CPBitmapButton methods !   
needsKeyDownInput
		"Private - Answer true if the receiver processes key-down events."
	#addedByOSI.
	^true! !

!CPBitmapButton methods !
click
    "Private"

    self
        press;
        releaseButton.! !

!CPBitmapButton methods !  
space
    "Private"

    ^5! !

!CPBitmapButton methods !
initialize
    "Private"

    pressed := false.
    super initialize.! !

!CP3DCheckBox methods !   
initialize
		"Private - Initialize the receiver."
	super initialize.
	picture := self defaultBitmap.
	onPicture := self defaultOnBitmap.! !

!CPHorizontalPictureButton methods !   
initialize
		"Private - Initialize the receiver"
	super initialize.
	highlighted := false.
	picture := CPCheckBoxSysBitmap.
	onPicture := CPCheckBoxOnSysBitmap.! !

!CP3DRadioButton methods !
dragTargetFormatsDefault
        "Private - answer the formats of drag objects that the receiver will accept."
    ^#( 'string' )! !

!CP3DRadioButton methods !  
selection: aBoolean
    "Set the selection of the reciever"

    super selection: aBoolean.
    aBoolean
        ifTrue:
            [self isHandleOk
                ifTrue:
                    [self turnOffSiblings.
                    ].
            ].! !

!CPHorizontalPictureButton methods !   
wmGetdlgcode: wParam
with: lParam
    "Private"

    ^DlgcRadiobutton! !

!CPBitmapButton methods ! 
displayWith: pen
inRect: inRect
clipRect: cRect
    "Private"

    | startY titleExtent space rect region |
    rect := self rect translateBy: inRect leftTop.
    pen
        foreColor: self foreColor;
        drawRectangle: rect;
        draw3DRect: rect
            depth: 2
            style: #out;
        fill: (rect insetBy: 3) color: self backColor;
        foreColor: self foreColor;
        backColor: self backColor.
    region := pen setClipRect: ((rect insetBy: 3) intersect: cRect).
    title isNil
        ifTrue:
            [picture isNil
                ifFalse:
                    [picture displayAt: (self extent - picture extent) // 2 + rect leftTop with: pen.
                    ].
            ]
        ifFalse:
            [titleExtent := self font stringExtent: title.
            titleExtent x: (self font wbStringWidth: title).
            pen setTextAlign: TaTop.
            picture isNil
                ifTrue:
                    [self
                            drawTitle: title
                            at: (self extent - titleExtent) // 2 + rect leftTop
                            with: pen]
                ifFalse:
                    [space := self space.
                    startY := (((self height - (picture height + space + titleExtent y)) // 2) max: 2) + rect top.
                    self
                            drawTitle: title
                            at: (self width - titleExtent x // 2 + rect left) @ (startY + picture height + space)
                            with: pen.
                    picture displayAt: (self width - picture width // 2 + rect left) @ startY with: pen.
                    ].
            ].
    self hasFocus & self pen notNil
        ifTrue:
            [self drawFocusRect.
            ].
    pen destroyRegion: region.! !

!CPHorizontalPictureButton methods !
highlight
    "Private"

    | buttonRect |
    highlighted
        ifFalse:
            [highlighted := true.
            buttonRect := (0 @ (self height - picture height // 2) extent: picture extent).
            self doGraphics: [self pen reverse: (buttonRect insetBy: 1)].
            ].! !

!CPBitmapToggle methods !  
releaseButton
    "Private"

    value := value not.
    self display.
    super releaseButton.! !

!CPBitmapToggle methods !  
isPushButton
        "Answer whether the receiver is an instance of a push button"
    ^false
! !

!CPBitmapButton methods ! 
press
    "Private"

    pressed := true.
    self highlight.! !

!CPBitmapButton methods ! 
wmGetdlgcode: wParam
with: lParam
    "Private"

    ^DlgcButton! !

!CPBitmapButton methods !  
rectToHighlight

	^self rect! !

!CPBitmapButton methods !
drawFocusRectColor: ignore
    "Private"

    | aRect titleExtent space pictureHeight |
    title isNil
        ifTrue:
            [picture isNil
                ifTrue:
                    [aRect := self rect insetBy: 6.
                    ]
                ifFalse:
                    [aRect := (self extent - picture extent) // 2 + self rect leftTop extent: picture extent.
                    ].
            ]
        ifFalse:
            [titleExtent := self font stringExtent: title.
            picture isNil
                ifTrue:
                    [pictureHeight := space := 0.
                    ]
                ifFalse:
                    [pictureHeight := picture height.
                    space := self space.
                    ].
            aRect := ((self width - titleExtent x // 2) @ ((self height - (pictureHeight + space + titleExtent y) // 2) + pictureHeight + space)) + self rect leftTop extent: titleExtent.
            ].
    self drawFocusRect: (aRect expandBy: 1).! !

!CPBitmapButton methods !
isButton
    "Private"

    ^true! !

!CPBitmapButton methods !  
onBitmap
	"Answer the bitmap displayed while the button is being pressed:
	 the 'on' bitmap."

    ^onPicture! !

!CPBitmapButton methods ! 
needsKeyUpInput
		"Private - Answer true if the receiver processes key-up events."
	#addedByOSI.
	^true! !

!CP3DRadioButton methods !   
label
    "Answer the textual label of the receiver."

    ^title! !

!CPBitmapButton methods !  
dragTargetFormatsDefault
        "Private - answer the formats of drag objects that the receiver will accept."
    ^#( 'string' 'bitmap' )! !

!CP3DRadioButton methods ! 
defaultOnBitmap
	"Answer the default bitmap displayed while the button
	 is being pressed: the 'on' bitmap."

    ^CPRadioButtonOnRedSysBitmap! !

!CPBitmapButton methods !
button1Down: point
	"Private"

	| highlighted |
	(self subpaneButton1Down: point)
		ifFalse: [^self].
	self press.
	highlighted := true.
	self
		whileMouseStillDown: [:currentMousePosition |
			(self rect containsPoint: self mouseLocation)
				ifTrue:
					[highlighted
						ifFalse:
							[self highlight.
							highlighted := true.
							]]
				ifFalse:
					[highlighted
						ifTrue:
							[self unHighlight.
							highlighted := false.
							]]].
	highlighted
		ifTrue: [
			self setFocus.
			self releaseButton].! !

!CPBitmapToggle methods !   
drawFocusRect
    "Private"

    | holdPicture |
    holdPicture := picture.
    onPicture notNil & value
        ifTrue:
            [picture := onPicture.
            ].
    super drawFocusRect.
    picture := holdPicture.! !

!CPBitmapToggle methods !
selection
    "Answer the selection of the reciever"

    ^value! !

!CPBitmapButton class methods ! 
constructEventsTriggered
    "Private - answer the set of events that instances of the
     receiver can trigger."

    ^super
        constructEventsTriggered addAll: #(#clicked);
        yourself! !

!CPBitmapToggle methods !   
initialize
    "Private"

    super initialize.
    value := false.! !

!CP3DRadioButton methods !  
releaseButton
    "Private"

    pressed := false.
    self unHighlight.
    value := true.
    self turnOffSiblings.
    self
        doGraphics:
            [self displayPicture: self pen inRect: self rect.
            ].
    self triggerEvents! !

!CPBitmapButton class methods !   
supportedEvents
    "Private"

    ^super
        supportedEvents add: #clicked;
        yourself! !

!CP3DRadioButton methods !   
setFocus
	"Private"

	(self propertyAt: #ignoreSetFocus ifAbsent: [false])
		ifFalse: [
			self selection: true.
			super setFocus].! !

!CPBitmapButton methods !
releaseButton
    "Private"

    pressed := false.
    self unHighlight.
    self triggerEvents! !

!CP3DCheckBox methods !
dragTargetFormatsDefault
        "Private - answer the formats of drag objects that the receiver will accept."
    ^#( 'string' )! !

!CPBitmapToggle methods !   
displayWith: pen
inRect: inRect
clipRect: clipRect
    "Private"

    | holdPicture |
    onPicture notNil
        ifTrue:
            [holdPicture := picture.
            value
                ifTrue:
                    [picture := onPicture.
                    ].
            super
                    displayWith: pen
                    inRect: inRect
                    clipRect: clipRect.
            picture := holdPicture.
            ]
        ifFalse:
            [super
                    displayWith: pen
                    inRect: inRect
                    clipRect: clipRect.
            value
                ifTrue:
                    [pen reverse: (inRect insetBy: 3).
                    ].
            ].! !

!CP3DRadioButton methods !   
isATabStop
    "Private - Answer true if the receiver is a tabstop"

    ^self selection & (super isATabStop | self isAGroupLeader not)! !

!CPBitmapToggle methods !
highlight
    "Private"

    self doGraphics: 
        [self pen
            draw3DRect: self rectToHighlight
            depth: 2
            style: #in
        ].! !

!CP3DRadioButton methods ! 
defaultBitmap
	 "Answer the default 'off' button bitmap."

    ^CPRadioButtonSysBitmap! !

!CP3DRadioButton methods !
triggerEvents
    "Private - reimplemented with the PARTS style 
		radio button's clicked: event value is the label."

    self event: #clicked. " OBSOLETE "
    self triggerEvent: #clicked: with: self label! !

!CPHorizontalPictureButton methods !   
selection: aBoolean
    "Set the selection on or off"

    value = aBoolean
        ifTrue: [^self].
    value := aBoolean.
    self isHandleOk & self pen notNil
        ifFalse: [^self].
    self
        doGraphics:
            [self displayPicture: self pen inRect: self rect.
            ].! !

!CPBitmapButton methods !  
drawTitle: aString
at: aPoint
with: pen
    "Private"

    pen
        font: self font;
        winDrawText: aString at: aPoint.! !
  
UndefinedObject removeSelector: #osiIgnoredInitializerSource!
   
"======== Initializers"!