"3.1.1.0"
!

Smalltalk at: #CPSystemBitmaps ifAbsentPut: [ Dictionary new ]!   
CPSystemBitmaps at: 'CPSteelPatternSysBitmap' ifAbsentPut: [ nil ]!   
CPSystemBitmaps at: 'CPCheckBoxSysBitmap' ifAbsentPut: [ nil ]!   
CPSystemBitmaps at: 'CPCheckBoxOnSysBitmap' ifAbsentPut: [ nil ]! 
CPSystemBitmaps at: 'CPRadioButtonSysBitmap' ifAbsentPut: [ nil ]!
CPSystemBitmaps at: 'CPRadioButtonOnSysBitmap' ifAbsentPut: [ nil ]!  
CPSystemBitmaps at: 'CPLittleUpArrowSysBitmap' ifAbsentPut: [ nil ]!  
CPSystemBitmaps at: 'CPLittleDownArrowSysBitmap' ifAbsentPut: [ nil ]!
CPSystemBitmaps at: 'CPRadioButtonOnRedSysBitmap' ifAbsentPut: [ nil ]!   
CPSystemBitmaps at: 'CPRadioButtonOnYellowSysBitmap' ifAbsentPut: [ nil ]!
CPSystemBitmaps at: 'CPRadioButtonOnBlackSysBitmap' ifAbsentPut: [ nil ]! 
CPSystemBitmaps at: 'CPRadioButtonOnBlueSysBitmap' ifAbsentPut: [ nil ]!  
CPSystemBitmaps at: 'CPRadioButtonOnGreenSysBitmap' ifAbsentPut: [ nil ]! 
CPSystemBitmaps at: 'CPRadioButtonOnCyanSysBitmap' ifAbsentPut: [ nil ]!  
CPSystemBitmaps at: 'CPRadioButtonOnMagentaSysBitmap' ifAbsentPut: [ nil ]!   
CPSystemBitmaps at: 'CPRadioButtonOnWhiteSysBitmap' ifAbsentPut: [ nil ]! 
CPSystemBitmaps at: 'CPCheckBoxOnRedCheckSysBitmap' ifAbsentPut: [ nil ]! 
CPSystemBitmaps at: 'CPCheckBoxOnGreenCheckSysBitmap' ifAbsentPut: [ nil ]!   
CPSystemBitmaps at: 'CPCheckBoxOnBlueCheckSysBitmap' ifAbsentPut: [ nil ]!
CPSystemBitmaps at: 'CPCheckBoxOnBlackCheckSysBitmap' ifAbsentPut: [ nil ]!   
CPSystemBitmaps at: 'CPCheckBoxOnWhiteCheckSysBitmap' ifAbsentPut: [ nil ]!   
CPSystemBitmaps at: 'CPCheckBoxOnYellowCheckSysBitmap' ifAbsentPut: [ nil ]!  
CPSystemBitmaps at: 'CPCheckBoxOnCyanCheckSysBitmap' ifAbsentPut: [ nil ]!
CPSystemBitmaps at: 'CPCheckBoxOnMagentaCheckSysBitmap' ifAbsentPut: [ nil ]! 
CPSystemBitmaps at: 'CPCheckBoxOnRedCrossSysBitmap' ifAbsentPut: [ nil ]! 
CPSystemBitmaps at: 'CPCheckBoxOnGreenCrossSysBitmap' ifAbsentPut: [ nil ]!   
CPSystemBitmaps at: 'CPCheckBoxOnBlueCrossSysBitmap' ifAbsentPut: [ nil ]!
CPSystemBitmaps at: 'CPCheckBoxOnBlackCrossSysBitmap' ifAbsentPut: [ nil ]!   
CPSystemBitmaps at: 'CPCheckBoxOnWhiteCrossSysBitmap' ifAbsentPut: [ nil ]!   
CPSystemBitmaps at: 'CPCheckBoxOnYellowCrossSysBitmap' ifAbsentPut: [ nil ]!  
CPSystemBitmaps at: 'CPCheckBoxOnCyanCrossSysBitmap' ifAbsentPut: [ nil ]!
CPSystemBitmaps at: 'CPCheckBoxOnMagentaCrossSysBitmap' ifAbsentPut: [ nil ]! 

SubPane subclass: #CPSubPane
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: 
    ' OperatingSystemConstants VirtualKeyConstants '!

CPSubPane subclass: #CPScrollingPane
  instanceVariableNames: 
    ' selectedCell selectionMode headerColor totalCells cellSize tempClipRect canResize canReorder canSort cursor wbDisplayContext '
  classVariableNames: ''
  poolDictionaries: 
    ' CharacterConstants GraphicsConstants OperatingSystemConstants '!   
CPScrollingPane class instanceVariableNames: ' fieldMargin cellInset headerInset '!   

Object subclass: #CPCLBField
  instanceVariableNames: 
    ' header selector printSelector fieldWidth justification font cachedWidth name foreColor backColor properties '
  classVariableNames: ''
  poolDictionaries: 
    ' CharacterConstants OperatingSystemConstants '!  

WBDisplayContext subclass: #SPDisplayContext
  instanceVariableNames: 
    ' font clipRect viewPortOrigin '
  classVariableNames: ''
  poolDictionaries: ''!

!CPScrollingPane methods !  
scrollAreaRectangle
    "Private"

    ^self headerExtent rightBottom: self rectangle rightBottom! !

!CPCLBField methods !  
fieldWidthAttribute
	"Private"

	^fieldWidth! !

!CPScrollingPane methods !  
cellSize
    "Private"

    ^cellSize! !

!CPCLBField methods !  
wbDisplayExtent: anObject with: aWBDisplayContext
	"Answer the pixel extent needed to fully display the anObject."

	self font notNil ifTrue: [aWBDisplayContext font: self font].
	aWBDisplayContext justification: self justification.
	^(anObject ifNil: ['']) wbDisplayExtentWith: aWBDisplayContext! !

!CPSubPane methods !  
dragTargetOperationsDefault
        "Private - answer the operations that the receiver can accept."
	^#( #copy )! !

!CPCLBField methods !
justification
    "Private"

    ^justification! !

!CPScrollingPane methods !   
exposedRectangle
    "Private - Answer the rectangle that needs to be drawn"

    self inWindowBuilder
        ifTrue: [^self wbDisplayRectangle].
    ^self currentClipRect! !

!CPScrollingPane methods !
getScrollRanges
    "Private - answer the scroll ranges of the window"

    "Make the vertical scroll bar represent cell scrolling
        rather than pixel scrolling."

    | h v minPtr maxPtr |
    minPtr := ExternalBuffer new: 2.
    maxPtr := ExternalBuffer new: 2.
    UserLibrary
            getScrollRange: self asParameter
            bar: SbHorz
            lpMinPos: minPtr asParameter
            lpMaxPos: maxPtr asParameter.
    h := maxPtr uShortAtOffset: 0.
    UserLibrary
            getScrollRange: self asParameter
            bar: SbVert
            lpMinPos: minPtr asParameter
            lpMaxPos: maxPtr asParameter.
    v := maxPtr uShortAtOffset: 0.
    "Added this line to convert cell max to pixel max."
    v := v * self cellSize y.
    ^h @ v! !

!CPScrollingPane methods !  
fullyVisibleCells
    "Private - Answer the number of cells that are fully visible"

    ^self scrollAreaRectangle extent // self cellSize! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPSubPane methods ! 
wmTimer: wordInteger
with: longInteger
	"Private - Process the timer message."

	CurrentEvents isEmpty ifTrue: [
		self noSpin ifFalse: [
			Notifier isButton1Down | Notifier isButton2Down ifTrue: [
				self sendMouseMoveInputEvent: #button1Move: with: self cursorWindowPosition]]].
	^nil! !

!CPScrollingPane methods ! 
button1DoubleClick: aPoint
    "Private"

    self doSetFocus.
	self triggerDoubleClickEvent.! !

!CPScrollingPane methods !
amountToScrollDown
    "Private"

    ^self amountToScrollUp negated! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPCLBField methods !  
fieldWidthString
    "Private"

    self autoFieldWidth
        ifTrue: [^'Auto']
        ifFalse: [^fieldWidth printString].! !

!CPScrollingPane methods !   
dragTargetOperationForSelf: dragSession
		"Answer the operation when source = target = self."
	(self dragTargetOperations includes: #move) ifFalse: [ ^nil ].
	^#move! !

!CPSubPane methods !   
subpaneButton1Down: aPoint
    "Private"

    ^(super button1Down: aPoint) ~= false! !

!CPScrollingPane methods !   
scrollVertical: scrollAmount
    "Private - Scroll the pane down by anInteger
      number of pixels (if positive) or up by
      the absolute value of anInteger (if negative)."

    self scrollTopCorner: 0 @ scrollAmount! !

!CPScrollingPane methods !   
dragCompatibility: anObject
	"Set the drag compatibility indicator.
	true	= consider all objects compatible - don't perform the normal check
	false	= consider all object incompatible - don't perform the normal check
	nil		= perform the normal check
	other	= send the #evaluateWithArguments: message to anObject
		with the object in question as the only argument
		and interpret the results as one of the three above."

	self propertyAt: #dragCompatibility put: anObject.! !

!CPSubPane methods !
setDefaultDragObjects: aCollection
    "Set the default drag & drop objects for the receiver"

    #obsoleteMethod.
    self propertyAt: #defaultDragObjects put: aCollection! !

!CPScrollingPane methods !
defaultCanResize
    "Private"

    ^false! !

!CPScrollingPane methods !
scrollableRectangle
    "Private - Answer the rectangular area that can be scrolled
     (i.e. the full area - the visible area)"

    | scrollExtent |
    scrollExtent := (self totalCells * self cellSize) - self scrollAreaRectangle extent max: 0 @ 0.
    scrollExtent := ((scrollExtent x + self cellSize x - 1) truncateTo: self cellSize x) @ ((scrollExtent y + self cellSize y - 1) truncateTo: self cellSize y).
    ^0 @ 0 extent: scrollExtent.! !

!CPSubPane methods !   
inWindowBuilder
    "Private"

    ^rectangle leftTop ~= (0 @ 0)! !

!CPCLBField methods !   
defaultFont
    "Private"

    ^SysFont! !

!CPScrollingPane methods !   
scrollTopCorner: aPoint
unlimited: ignored
    "Private"

    | oldCorner scrollRect point scrollRanges |
    oldCorner := topCorner deepCopy.
    topCorner := topCorner - aPoint.
    scrollRect := self scrollableRectangle.
    topCorner y: ((topCorner y min: scrollRect height) max: 0).
    scrollRanges := self getScrollRanges.
    topCorner x: ((topCorner x min: scrollRanges x) max: 0).
    oldCorner = topCorner
        ifTrue: [^false].
    oldCorner y = topCorner y
        ifTrue:
            [scrollRect := self verticalScrollAreaRectangle.
            ]
        ifFalse:
            [
            "If they scroll in both directions at once, we'd better not
     try blitting, since both row and column headers will both
     need to be updated."
            oldCorner x = topCorner x
                ifFalse:
                    [self
                        invalidateRect: self rectangle;
                        updateWindow.
                    self event: #scrolled. " OBSOLETE "
                    self triggerEvent: #scrolled.
                    ^oldCorner ~= topCorner].
            scrollRect := self horizontalScrollAreaRectangle.
            ].
    point := oldCorner - topCorner.
    point y < 0
        ifTrue: [point y: (point y max: scrollRect height negated)]
        ifFalse: [point y: (point y min: scrollRect height)].
    parent isDialogTopPane
        ifTrue: [scrollRect := scrollRect insetBy: 1].
    UserLibrary
            scrollWindow: handle
            xAmount: point x
            yAmount: point y
            lpRect: scrollRect asParameter
            clipRect: scrollRect asParameter.
    self updateWindow.
    self event: #scrolled. " OBSOLETE "
    self triggerEvent: #scrolled.
    ^oldCorner ~= topCorner! !

!CPSubPane methods !
rect
    "Private"

    ^0 @ 0 extent: self extent! !

!CPScrollingPane methods !
getTopCell
    "Private - Answer the upper left visible cell"

    ^(topCorner // self cellSize) + 1! !

!CPSubPane methods !
defaultStyle
    "Private - Answer an Integer with appropriate styles in it."

    ^WsChild | WsVisible! !

!CPSubPane methods ! 
wmLbuttondown: wParam
with: longInteger
    "Private - Process left button down message."

    self disabled
        ifTrue: [^nil].
    self setFocus.
    ^super wmLbuttondown: wParam with: longInteger! !

!CPScrollingPane methods !
dragTargetOperationsDefault
        "Private - answer the operations that the receiver can accept."
	^#( #move #copy )! !

!CPScrollingPane methods ! 
fieldMargin
    "Private - answer the width in pixels on each side of a field"

    "^self font width * 3"
	^self class fieldMargin! !

!CPScrollingPane methods !  
defaultCanReorder
    "Private"

    ^false! !

!CPScrollingPane methods !   
headerColor

    ^headerColor! !

!CPSubPane methods !
rectanglePrivate: aRect
    "Private"

    rectangle := aRect.! !

!CPScrollingPane methods !
canResize
    "Answer aBoolean indicating whether the user can dynamically resize the
    column widths by dragging the divider between the column labels."

    ^canResize! !

!CPSubPane methods !
stopMouseMoveTimer
	"Stop the mouse movement timer."

	UserLibrary killTimer: self handle idEvent: nil.! !

!CPScrollingPane methods !   
amountToPageDown
    "Private"

    ^self amountToPageUp negated! !

!CPCLBField methods !   
wbDisplayWith: aWBDisplayContext

	font notNil ifTrue: [aWBDisplayContext font: self font].
	aWBDisplayContext justification: self justification.
	self header wbDisplayWith: aWBDisplayContext.! !

!CPScrollingPane methods ! 
tempClipRect
    "Private"

    ^(tempClipRect := self propertyAt: #tempClipRect) isNil
        ifTrue: [ self rect ]
        ifFalse: [ tempClipRect ]! !

!CPScrollingPane class methods !   
maxRowsToAutoSize
    "Answer the maximum # of rows that calcFieldSizes checks
     to determine an appropriate column width. Decreasing this
     number will yield faster load times. Increasing this number
     will yield a more accurate column width."

    ^32! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPScrollingPane methods !
cellSize: anObject
    "Private"

    cellSize := anObject! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPScrollingPane class methods !
supportedEvents
    "Private"

    ^super
        supportedEvents add: #doubleClickSelect;
        add: #select;
        add: #commitSelection;
        add: #scrolled;
        yourself! !

!CPSubPane methods !   
basicRightButtonScroll: point
        "Private - Do right button scrolling."
	^super rightButtonScroll: point! !

!CPSubPane methods !
finalizeMoveOperation: dragDrop
    "Private - Do Nothing"

    #obsoleteMethod.! !

!CPScrollingPane methods !  
amountToPageUp
    "Private"

    ^self rectangle height - self cellSize y roundTo: self cellSize y.! !

!CPScrollingPane methods !  
cursor
    "Private"

    ^cursor! !

!CPCLBField methods !  
headerLineCount
    "Private"

    ^(self header occurrencesOf: Lf) + 1! !

!CPSubPane methods ! 
triggerNeedsContentsEvent

    self event: #getContents. " OBSOLETE "
    self triggerEvent: #needsContents.! !

!CPScrollingPane methods !  
scrollBarWidth
    "Private"

    ^UserLibrary getSystemMetrics: SmCxvscroll! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPSubPane methods !   
displayWith: aPen
inRect: aRect
    "Private"

    aPen
        rectangle: aRect;
        place: aRect center;
        centerText: self class name.! !

!CPSubPane methods ! 
keyboardInput: aKeyboardInputEvent
        "Private - keyboard input was received.  Process cursor keys."
    | virtualKey |
    ( virtualKey := aKeyboardInputEvent virtualKey ) notNil ifTrue: [
        ( virtualKey == UpKey or: [ virtualKey == LeftKey ] )
            ifTrue: [ ^( self tabScope previousInGroup: self ) setFocus ].
        ( virtualKey == DownKey  or: [ virtualKey == RightKey ] )
            ifTrue: [ ^( self tabScope nextInGroup: self ) setFocus ].
        ( virtualKey == TabKey or: [ virtualKey == BacktabKey ] )
            ifTrue: [ ^self tabKeyInput: aKeyboardInputEvent ] ].
    ^super keyboardInput: aKeyboardInputEvent! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPSubPane methods !  
dragTargetOperationFor: dragSession
        "Private - answer the operation that the reciever would perform
        for the current drag-drop transfer at the current location, or nil
        if invalid."
    | dragFormats dragOperations dragObject operation |
    self isDragTarget ifFalse: [ ^nil ].
    ( dragFormats := self dragTargetFormats ) isNil ifTrue: [ ^nil ].
    ( dragOperations := self dragTargetOperations ) isNil ifTrue: [ ^nil ].
    ( dragSession objects size > 1 and: [ self dragTargetMultipleItem not ] ) ifTrue: [ ^nil ].

	"There are some complications when
		(source == target) & (target == self)
		so don't allow it for now.
		See 'dragTargetDropDefault:' "
	#osiHack.
	dragSession source == self ifTrue: [ ^self dragTargetOperationForSelf: dragSession ].

    dragObject := dragSession objects
		detect: [ :each | self isCompatibleDragObject: each ]
		ifNone: [ ^nil ].

	operation := dragSession impliedOperation
		ifNil: [ dragSession defaultOperation ].
	(dragOperations includes: operation)
		ifFalse: [ operation := dragOperations first ].

	"If a move operation, then check to see that all objects can be
		accepted so that no objects are 'lost' when moved."
	operation = #move ifTrue: [
		dragSession objects do: [ :each |
			(self isCompatibleDragObject: each) ifFalse: [ ^nil ] ] ].
	^operation! !

!CPScrollingPane methods !  
setScrollRanges
    "Private - Set the ranges for the horizontal and vertical
     scroll bars."

    "Make the vertical scroll bar represent cell scrolling
        rather than pixel scrolling."

    | rangeRect minHorz maxHorz minVert maxVert rect fullExtent |
    self isHandleOk
        ifFalse: [^self].
    rangeRect := self scrollableRectangle.
    minHorz := 0.
    maxHorz := rangeRect width.
    minVert := 0.
    maxVert := rangeRect height.
    (self style notNil and: [self style bitAnd: WsHscroll]) = 0
        ifTrue: [maxHorz := 0].
    (self style notNil and: [self style bitAnd: WsVscroll]) = 0
        ifTrue: [maxVert := 0].
    rect := self realRectangle.
    fullExtent := self fullExtent.
    (rect width >= fullExtent x)
        ifTrue:
            [maxHorz := 0.
            ].
    maxHorz > 0
        ifTrue:
            [rect height >= (fullExtent y + self scrollBarHeight)
                ifTrue: [maxVert := 0].
            ]
        ifFalse:
            [rect height >= fullExtent y
                ifTrue: [maxVert := 0].
            ].
    maxVert > 0
        ifTrue:
            [maxVert := maxVert + cellSize y - 1 // cellSize y.
            "maxVert := maxVert / cellSize y.
            maxVert := (maxVert / (maxVert / 32767) ceiling) truncated."
            ].
    UserLibrary
            setScrollRange: self asParameter
            bar: SbHorz
            min: minHorz
            max: maxHorz
            redraw: false.
    UserLibrary
            setScrollRange: self asParameter
            bar: SbVert
            min: minVert
            max: maxVert
            redraw: false! !

!CPSubPane methods ! 
backColor: aColor
	"Set the backcolor and force a repaint."

	super backColor: aColor.
	self redraw.! !

!CPSubPane methods !   
foreColor
	"Answer the foreground color of the receiver."

	^super foreColor ifNil: [self defaultForeColor]! !

!CPScrollingPane methods !   
canSort: aBoolean
    "Set whether the user can sort the entire list by right clicking
    on a column heading. (Shift right-click sorts in reverse order.)"

    canSort := aBoolean! !

!CPScrollingPane methods !
wbDisplayContext
	"Answer a new window builder display context for the receiver."

	^wbDisplayContext ifNil: [
		wbDisplayContext := self wbDisplayContextDefault]! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPCLBField methods !   
autoFieldWidth
    "Private"

    ^fieldWidth isNil! !

!CPScrollingPane class methods ! 
cellInset

	^cellInset ifNil: [
		cellInset := self defaultCellInset]! !

!CPScrollingPane methods ! 
selectionMode: aSelector
        "Set the selection mode."
    selectionMode :=
        aSelector = #cell
            ifTrue: [ nil ]
            ifFalse: [ aSelector ].! !

!CPSubPane methods ! 
lighterColor
    "Private"

    ^Color white! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPScrollingPane methods ! 
initialize
    "Private"

    super initialize.
    headerColor := self defaultHeaderColor.
    topCorner := 0 @ 0.
    canResize := self defaultCanResize.
    canReorder := self defaultCanReorder.
    canSort := self defaultCanSort.! !

!CPScrollingPane methods !
rect
    "Private"

    ^self inWindowBuilder
        ifTrue: [rectangle]
        ifFalse: [super rect].! !

!CPSubPane methods !  
isCompatibleDragObject: aDragObject
    "Private - Is <aDragObject> compatible with the receiver"

	(self dragTargetFormats ifNil: [ ^false ])
		do: [ :each |
			(aDragObject hasFormat: each) ifTrue: [ ^true ] ].
	^false! !

!CPScrollingPane methods !   
amountToScrollRight
    "Private"

    ^self amountToScrollLeft negated! !

!CPScrollingPane methods !   
boundedCellForPoint: aPoint
    "Private - make sure cell is no more than one cell outside the
     visible area (for the sake of smoother drag-scrolling)"

    | cell topCell bottomCell |
    cell := self cellForPoint: aPoint.
    (self scrollAreaRectangle containsPoint: (self pointForCell: cell) abs)
        ifTrue: [^cell].
    topCell := self getTopCell - 1.
    bottomCell := topCell + self fullyVisibleCells + 1.
    ^(cell max: topCell) min: bottomCell! !

!SPDisplayContext methods ! 
clipRect: aRectangle

    clipRect := aRectangle.! !

!CPScrollingPane methods !  
cell: cell1
differsFrom: cell2
    "Private"

    ^cell1 ~= cell2! !

!CPScrollingPane methods !
close
	"Private - Close the receiver."

	self clearWBDisplayContext.
	^super close! !

!CPCLBField methods !
fieldPixelWidth
    "Private"

    cachedWidth isNil
        ifTrue:
            [cachedWidth := self fieldWidth * 
                (font isNil ifTrue: [SysFont] ifFalse: [font]) width.
            ].
    ^cachedWidth! !

!CPSubPane methods !  
gettingFocus
    "Private - The receiver is getting the input focus."

    self subPaneWithFocus: self.
    self triggerGettingFocus! !

!CPScrollingPane methods ! 
cellsToDraw
    "Private - Answer a rectangle describing the range of cells to draw"

    | drawRect |
    drawRect := self exposedRectangle.
    self inWindowBuilder
        ifFalse: [drawRect := drawRect intersect: self currentClipRect].
    "Take into account that rectangle origin may be non-zero for
     WB based drawing"
    drawRect := (drawRect leftTop leftAndUp: rectangle leftTop) extentFromLeftTop: drawRect extent.
    drawRect := (drawRect leftTop max: self headerExtent) rightBottom: drawRect rightBottom.
    ^(self cellForPoint: drawRect leftTop) rightBottom: (self cellForPoint: drawRect rightBottom).! !

!CPScrollingPane methods !   
scrollBarHeight
    "Private"

    ^UserLibrary getSystemMetrics: SmCyhscroll! !

!CPScrollingPane methods ! 
isCompatibleDragObject: aDragObject
    "Private - Is <aDragObject> compatible with the receiver"

	^(self compatibleDragObjectDataFor: aDragObject) notNil! !

!CPSubPane methods ! 
disabled
    "Since Digitalk doesn't save the state of whether we're
      disabled before we're built, the test above could have failed, yielding
      no way to enable a cp subpane"

    ^(self propertyAt: #disabled) notNil! !

!CPCLBField methods !
backColor: aColorOrSelector
    "Private"

    backColor := aColorOrSelector.! !

!CPSubPane methods !   
rightButtonScroll: point
        "Private - Do right button scrolling."! !

!CPScrollingPane methods ! 
verticalScrollAreaRectangle
    "Private - Answer the rectangular are that should be scrolled if we
    scroll vertically (don't scroll the vertical  header)"

    ^self headerExtent x + 1 @ 0 rightBottom: self rectangle rightBottom! !

!CPSubPane methods !   
defaultFont
    "Private"

    ^SysFont! !

!CPScrollingPane methods !   
amountToPageRight
    "Private"

    ^self amountToPageLeft negated! !

!CPSubPane methods ! 
button2Up: aPoint
        "Private - signal the right clicked event."
		"Parts expect to see rightClicked events."

    self triggerEvent: #rightClicked
        ifNotHandled: [ super button2Up: aPoint ].
    self clearMouseCapture.! !

!CPScrollingPane methods !
showFocus
    "Private"
    "self showFocusInCell: selectedCell"! !

!CPScrollingPane class methods ! 
headerInset: aRectangleOrPoint

	headerInset := aRectangleOrPoint.! !

!CPCLBField methods !  
headerHeight
    "Private"

    ^self headerLineCount * self font height! !

!CPCLBField methods !   
justificationOffsetFor: aString
    "Private - Answer the offset within the field that the
     text should start displaying at for correct justification"

    | offset width |
    (justification = #left)
        ifTrue:
            [offset := 0.
            ]
        ifFalse:
            [aString isBitmap
                ifTrue: 
                    [width := aString width 
                    ]
                ifFalse: 
                    [width := self font wbStringWidth: aString 
                    ].
            (justification = #right)
                ifTrue:
                    [offset := self fieldPixelWidth - width.
                    ]
                ifFalse:
                    [offset := self fieldPixelWidth - width // 2.
                    ].
            ].
    ^offset! !

!CPSubPane methods ! 
whileMouseStillDownPrim: aBlock
	"Private"

	| moveSelectors upSelectors allSelectors |
	moveSelectors := #(#button1Move: #button2Move:).
	upSelectors := #(#button1Up: #button1UpShift: #button2Up:).
	allSelectors := moveSelectors, upSelectors.

	self
		captureMouseInput;
		startMouseMoveTimer.
	Notifier
		consumeInputUntil:
			[:event |
			(allSelectors includes: event selector)
				ifTrue: [
					((moveSelectors includes: event selector) and: [self noSpin]) ifFalse: [
						#osiHack.
						"Sometimes the first argument is -1 @ -1 when it should
							be something else.  If it is then substitute the current
							cursor location."
						aBlock evaluateFor: (
							event arguments first = (-1 @ -1)
								ifTrue: [self cursorWindowPosition]
								ifFalse: [event arguments first copy])]]
				ifFalse: [event perform].
			upSelectors includes: event selector
			].
	self
		stopMouseMoveTimer;
		clearMouseCapture.! !

!CPScrollingPane methods !
realRectangle
    "Private - Answer the rectangle representing the fully visible area of the
     window, taking into account any scrollbars that might be on it."

    | range height width |
    self inWindowBuilder
        ifTrue: [^0 @ 0 extent: self wbDisplayRectangle extent].
    width := height := 0.
    range := self getScrollRanges.
    range x ~= 0
        ifTrue:
            [width := self scrollBarWidth.
            ].
    range y ~= 0
        ifTrue:
            [height := self scrollBarHeight.
            ].
    ^0 @ 0 extent: self frameRectangle extent - (width @ height).! !

!CPScrollingPane methods ! 
wbDisplayRectangle
    "Private - WindowBuilder drawing sets up rectangle for us"

    ^rectangle! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPScrollingPane methods !
headerMargin
    "Private - answer the height (beyond the font height) of the
     header in pixels"

    ^5! !

!CPScrollingPane methods ! 
dragCompability

	#obsoleteMethod.
	^self dragCompatibility! !

!CPScrollingPane methods !   
scrollHorizontal: scrollAmount
    "Private - Scroll the pane right by anInteger
      number of pixels (if positive) or left by
      the absolute value of anInteger (if negative)."

    self scrollTopCorner: scrollAmount @ 0! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPScrollingPane methods ! 
fullExtent
    "Private - Answer the logical extent of ourselves, including any
     header and all the cells sizes."

    ^totalCells * cellSize + self headerExtent.! !

!CPScrollingPane methods !   
rectForCell: cell
    "Private Answer the rectangle that completely encompasses the
     cell. This will include a one pixel border all the way
     around the cell."

    | point |
    point := self pointForCell: cell.
    ^Rectangle leftTop: point extent: (self pixelCellWidth: cell x) @ self cellSize y + 1! !

!CPScrollingPane methods ! 
triggerColumnReorderedEvent

    self event: #columnReordered. " OBSOLETE "
    self triggerEvent: #columnReordered: with: self columnReordered.! !

!CPScrollingPane methods !  
updateSliders
    "Private - Update the slider boxes in the scrollbars."

    handle = NullHandle
        ifTrue: [^self].
    self updateVerticalSlider.
    self updateHorizontalSlider! !

!CPSubPane methods !
wmErasebkgnd: wordInteger
with: longInteger
    "Private"

    ^1! !

!CPScrollingPane methods !
amountToPageLeft
    "Private"

    ^(self rectangle width - self scrollBarWidth) roundTo: self cellSize x! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPScrollingPane methods !   
dragCompability: anObject
	"Set the drag compatability indicator.
	true	= consider all objects compatible - don't perform the normal check
	false	= consider all object incompatible - don't perform the normal check
	nil		= perform the normal check
	other	= send the #evaluateWithArguments: message to anObject
		with the object in question as the only argument
		and interpret the results as one of the three above."

	#obsoleteMethod.
	self dragCompatibility: anObject.! !

!CPScrollingPane methods !  
dragCompatibility

	^self propertyAt: #dragCompatibility ifAbsent: [nil]! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPSubPane methods !
cpStyle: aSymbol
    "Private"

    self propertyAt: #cpStyle put: aSymbol.! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPSubPane methods !
foreColorAttribute
	"Answer the foreground color of the receiver."

	^super foreColor! !

!CPScrollingPane methods ! 
selectionMode
        "Answer the selection mode."
    ^selectionMode ifNil: [ ^#cell ]! !

!CPScrollingPane methods !
updateHorizontalSliderTo: integer
    "Private - Set the slider box in the scrollbar to integer."

	self isHandleOk ifFalse: [ ^self ].
    UserLibrary
            setScrollPos: self asParameter
            bar: SbHorz
            position: integer
            redraw: true.! !

!CPCLBField methods !
header
    "Private"

    header isNil
        ifTrue: [header := ''].
    ^header! !

!SPDisplayContext methods ! 
font: aFont

	font := aFont.
	self pen notNil ifTrue: [
		self pen font = aFont ifFalse: [
			self pen font: aFont]].! !

!CPSubPane methods ! 
noSpin
    "Enable or disable the no spin option."

    ^(self propertyAt: #noSpin) = true
! !

!CPSubPane methods !
isCompatible: anObject
    "Is <anObject> compatible with the receiver"

	#obsoleteMethod.
    ^false! !

!CPSubPane methods !  
mouseLocation
    "Private"

    ^Cursor offset mapToWindow: self.! !

!CPScrollingPane methods !
defaultHeaderColor
    "Private"

    ^Color windowBackground! !

!CPSubPane methods !   
dragTargetOperationForSelf: dragSession
		"Answer the operation when source = target = self."
	^nil! !

!CPSubPane methods !  
whileMouseStillDown: aBlock
    "Private"

	| sourceLocation |
    self isDragSource
        ifTrue:
            [sourceLocation := self dragSourceLocation.
            sourceLocation isNil ifTrue: [sourceLocation := self cursorWindowPosition].
            aBlock evaluateFor: sourceLocation.
            self
                whileMouseStillDownDo: [:currentMousePosition |
                    (self dragOnMove and: [ self isDragSourceInitiation: self cursorWindowPosition ])
                        ifTrue:
                            [self dragOnMove: nil location: nil.
					        self doDragDropAt: sourceLocation]].
            ]
        ifFalse:
            [self whileMouseStillDownDo: aBlock].! !

!CPCLBField class methods !
new

    ^super new initialize! !

!CPSubPane methods !   
getDefaultDragObjects
    "Private"

    | dragObjects |
    #obsoleteMethod.
    (dragObjects := self propertyAt: #defaultDragObjects) isNil
        ifTrue: [^nil].
    self renderAsObjects
        ifFalse:
            [dragObjects := dragObjects
                collect:
                    [:each |
                    each asString]].
    ^dragObjects! !

!CPScrollingPane methods ! 
reframe
    "Private - the window just resized"

	self isHandleOk ifFalse: [
		OperatingSystem isOS2 ifTrue: [^self]].
    self setScrollRanges.
    self scrollIfNecessary.
    self updateSliders.! !

!CPScrollingPane class methods !
stringWidth: aString
    "Private"

    | width string |
    width := 0.
    string := ReadStream on: aString.
    [string atEnd]
        whileFalse:
            [width := width max: string nextLine size.
            ].
    ^width! !

!CPSubPane methods !   
windowClass
    "Private - Answer the window class of CPSubPane."

    | className wndClass address answer |
    className := 'CPSub'.
    wndClass := WinWindowClass new.
    answer := UserLibrary
            getClassInfo: OperatingSystem hInstanceExe
            className: className asParameter
            wndClass: wndClass asParameter.
    answer
        ifTrue: [^className].
    UserLibrary
            getClassInfo: OperatingSystem hInstanceExe
            className: Window windowClass asParameter
            wndClass: wndClass asParameter.
    address := ExternalAddress copyToNonSmalltalkMemoryZ: className.
    wndClass
        style: CsDblclks | CsVredraw | CsHredraw;
        className: address asParameter;
        hIcon: 0;
        hBrush: 0.
    (UserLibrary registerClass: wndClass asParameter) = 0
        ifTrue: [^self osError].
    address free.
    ^className! !

!CPSubPane methods !   
display
    "Private"

    self
        doGraphics:
            [self
                    displayWith: self pen
                    inRect: self rect
                    clipRect: self rect].! !

!CPSubPane methods !
backColor
	"Answer the background color of the receiver."

	^super backColor ifNil: [self defaultBackColor]! !

!CPScrollingPane methods !   
totalCells
    "Private"

    ^totalCells! !

!CPScrollingPane methods ! 
keepCellVisible: aCell
    "Private - scroll the window to make the cell visible if
     necessary"

    | bottomCell topCell newX newY newTopCell |
    self isHandleOk ifFalse: [ ^false ].
    topCell := self getTopCell.
    bottomCell := self getBottomCell.
    (((topCell rightBottom: bottomCell) containsPoint: aCell) and: [topCell x ~= aCell x])
        ifTrue: [^false].
    newX := self getClosestScrollPos: aCell x within: topCell x @ bottomCell x.
    newY := self getClosestScrollPos: aCell y within: topCell y @ bottomCell y.
    newTopCell := newX @ newY min: totalCells.
    topCell = newTopCell ifTrue: [ ^false ].
    self setTopCell: newTopCell.
    ^true! !

!CPScrollingPane methods !   
triggerScrolledEvent
		"Private"
    self event: #scrolled. " OBSOLETE "
    self triggerEvent: #scrolled.! !

!CPSubPane methods !  
disable

    self disabled
        ifTrue: [^self].
    "Since Digitalk doesn't save the state of whether we're
      disabled before we're built, the test above could have failed, yielding
      no way to enable a cp subpane"
    self propertyAt: #disabled put: true.
    self propertyAt: #holdForeColor put: self foreColor.
    self foreColor: Color darkGray.
    super disable.
    self isHandleOk
        ifTrue: [self invalidateRect: nil].! !

!CPSubPane methods !   
startMouseMoveTimer
	"Start the mouse movement timer.
		This simulate a #mouseMove: event at the specified interval
		even it the mouse has not actually moved."

	UserLibrary
			setTimer: self handle
			idEvent: nil
			elapsedTime: 50
			timerFunc: nil.! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPScrollingPane class methods !
fieldMargin: anInteger

	fieldMargin := anInteger.
	self cellInset: nil.! !

!CPScrollingPane methods !  
wmVScroll: aWordInteger
with: aLongInteger
    "Private - handle vertical scrolling"

    | type maxVert factor pos |
    type := aWordInteger lowWord.
    type = SbLineup
        ifTrue: [self scrollVertical: self amountToScrollUp].
    type = SbLinedown
        ifTrue: [self scrollVertical: self amountToScrollDown].
    type = SbPageup
        ifTrue: [self scrollVertical: self amountToPageUp].
    type = SbPagedown
        ifTrue: [self scrollVertical: self amountToPageDown].
    (type = SbThumbposition) | (type = SbThumbtrack)
        ifTrue:
            [pos := aWordInteger highWord.
            maxVert := self scrollableRectangle height / cellSize y.
            factor := (maxVert / 32767) ceiling.
            pos := pos * factor.
            pos > (maxVert / 2)
                ifTrue: [pos := pos + factor - 1].
            pos := pos * cellSize y.
            self scrollVertical: self topCorner y - pos.
            ^nil].
    self updateVerticalSlider.
    ^nil! !

!CPSubPane methods !   
backColorAttribute
	"Answer the background color of the receiver."

	^super backColor! !

!CPScrollingPane class methods !   
constructEventsTriggered
    "Private - answer the set of events that instances of the
     receiver can trigger."

    ^super
        constructEventsTriggered addAll: #(#doubleClickSelect: #select: #aboutToChange #scrolled);
        yourself! !

!CPScrollingPane methods ! 
setTopCell: aCell
    "Private"

    | newTop |
    newTop := (aCell - 1) * self cellSize.
    newTop x: (self rectForCell: aCell) left - self headerExtent x + topCorner x.
    self scrollTopCorner: topCorner - newTop.
    self inWindowBuilder
        ifTrue: [^self].
    self updateVerticalSlider.
    self updateHorizontalSlider.! !

!CPSubPane methods ! 
contents: ignore
    "Private"! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPCLBField methods !  
wbDisplay: anObject with: aWBDisplayContext

	self font notNil ifTrue: [aWBDisplayContext font: self font].
	aWBDisplayContext justification: self justification.
	(anObject ifNil: ['']) wbDisplayWith: aWBDisplayContext.! !

!CPScrollingPane methods !  
triggerColumnResizedEvent

    self event: #columnResized. " OBSOLETE "
    self triggerEvent: #columnResized: with: self columnResized.! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPScrollingPane methods !
button1Down: aPoint
	"Private"

	| cell point currentSelection lastSelection |
	(self subpaneButton1Down: aPoint)
		ifFalse: [^self].
	self doSetFocus.
	currentSelection := selectedCell.
	self isOkToChange == false ifTrue: [
		self whileMouseStillDown: [:currentMousePosition | ].
		self updateSelection.
		self unHighlightCell: currentSelection.
		self highlightCell: selectedCell.
		^self ].
	self doGraphics: [
		self whileMouseStillDown:[ :eachPoint |
			point := eachPoint.
			cell := self boundedCellForPoint: point.
			(self cell: currentSelection differsFrom: cell) & (self inBounds: cell)
				ifTrue:
					[(currentSelection isNil or: [(self isDisabled: currentSelection) not])
						ifTrue: [lastSelection := currentSelection].
					self unHighlightCell: currentSelection.
					self dragScrolls
						ifTrue:
							[self keepCellVisible: cell.
							].
					selectedCell := currentSelection := cell.
					self highlightCell: cell.
					].
			].
	].
	(self isDisabled: currentSelection)
		ifTrue:
			[self unHighlightCell: currentSelection.
			lastSelection isNil
				ifFalse: [selectedCell := lastSelection].
			self keepSelectionVisible.
			self highlightCell: selectedCell.
			currentSelection isNil ifFalse: [
				currentSelection y > self contents size ifFalse: [
					(Smalltalk at: #Terminal) bell "UserLibrary messageBeep: 0"]]]
		ifFalse:
			[selectedCell := currentSelection.
			].
	self updateSelection.
	self triggerSelectEvent.! !

!CPScrollingPane methods !
isCompatibleObject: anObject
	"Is <anObject> compatible with the receiver"

	^true! !

!CPScrollingPane methods !
defaultExtendedStyle
        "Private - answer the default extended style flags for the
        receiver.  Add the 3d border style."
    ^WsExClientedge! !

!CPScrollingPane methods !  
wbDisplayContextDefault
	"Answer a new window builder display context for the receiver."

	^super wbDisplayContext
		scale: false;
		wrap: true;
		yourself! !

!CPScrollingPane class methods !  
defaultBackColor
    "Private"

    ^Color windowBackground! !

!CPScrollingPane methods !   
keepSelectionVisible
    "Private"

    self isHandleOk
        ifFalse: [^false].
    ^self keepCellVisible: selectedCell.! !

!Dictionary methods !  
wbAttributeNamed: aSymbol
	"Answer the attribute of the receiver named <aSymbol>"
	#addedByOSI.
	^self at: aSymbol ifAbsent: [
		super wbAttributeNamed: aSymbol ]! !

!CPScrollingPane methods !   
scrollTopCorner: aPoint
    "Private"

    ^self scrollTopCorner: aPoint unlimited: false.! !

!CPScrollingPane methods !
drawMovingLine: x
    "Private"

    self doGraphics: [
        self pen
            setForegroundMode: MixRuleNotXor;
            place: x @ 0;
            goto: x @ self rect height;
            setForegroundMode: MixRuleDefault ].! !

!CPScrollingPane methods !
scrollIfNecessary
    "Private - force us to scroll if we just got smaller and are
     scrolled out"

    | newTopCorner fullExtent visibleExtent delta |
    self isHandleOk
        ifFalse: [^self].
    fullExtent := self fullExtent.
    visibleExtent := self realRectangle extent.
    newTopCorner := topCorner deepCopy.
    (fullExtent x < (visibleExtent x + topCorner x))
        ifTrue:
            [newTopCorner x: (fullExtent x - visibleExtent x max: 0).
            ].
    (fullExtent y < (visibleExtent y + topCorner y))
        ifTrue:
            [newTopCorner y: (fullExtent y - visibleExtent y max: 0).
            ].
    (newTopCorner ~= topCorner)
        ifTrue:
            [delta := topCorner - newTopCorner.
            delta := (delta x roundTo: self cellSize x) @ (delta y roundTo: self cellSize y).
            self scrollTopCorner: delta.
            ].! !

!String methods !  
wbDisplayExtentWith: aWBDisplayContext
	"Answer the pixel extent needed to fully display the receiver."

	| width stream height font |
	#addedByOSI.
	width := 0.
	height := 0.
	font := aWBDisplayContext font.
	stream := self asStream.
	[stream atEnd] whileFalse: [
		width := width max: (font wbStringWidth: stream nextLine).
		height := height + 1].
	^width @ ((height max: 1) * font height)! !

!CPCLBField methods !  
windowsJustification
    "Private"

    justification = #left
        ifTrue: [^SsLeft].
    justification = #right
        ifTrue: [^SsRight].
    justification = #center
        ifTrue: [^SsCenter].
    self error: 'Invalid Justification'.! !

!CPSubPane methods ! 
enable
    "Since Digitalk doesn't save the state of whether we're
      disabled before we're built, the test above could have failed, yielding
      no way to enable a cp subpane"
    "Added test to avoid blinkiness."

    self disabled
        ifFalse: [^self].
    self propertyAt: #disabled put: nil.
    self foreColor: (self propertyAt: #holdForeColor).
    super enable.
    self invalidateRect: nil.! !

!CPSubPane methods !
drawFocusRect: aRect
    "Private"

    self pen notNil
        ifTrue:
            [self
                doGraphics:
                    [self
                        pen foreColor: Color black;
                        drawFocusRect: aRect].
            ].! !

!CPScrollingPane methods !  
triggerSelectEvent
		"Private"
    self event: #select. " OBSOLETE "
    self triggerEvent: #select: with: self selectedItem.! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPScrollingPane methods !
pixelCellWidth: column
    "Private"

    ^self cellSize x! !

!CPScrollingPane methods !
visibleCells
    "Private - Answer the number of cells that are full or partially visible"

    ^((self scrollAreaRectangle extent - 1) // self cellSize) + 1! !

!CPScrollingPane methods ! 
horizontalScrollAreaRectangle
    "Private - Answer the rectangular are that should be scrolled if we
    scroll horizontally (don't scroll the horizontal header)"

    ^0 @ self headerExtent y rightBottom: self rectangle rightBottom! !

!CPSubPane methods !  
updateSliders
    "Private"! !

!CPSubPane methods !   
defaultDroppedOn: aDragDropList
    "Accept the drag and drop. This is the default handler for
      the #dragDropped: event."

    #obsoleteMethod.
    aDragDropList items notEmpty
        ifTrue:
            [self
                contents:
                    (aDragDropList items
                    detect:
                        [:item |
                        self isCompatible: item]
                    ifNone: [^nil])]! !

!CPCLBField methods !
backColor
    "Private"

    ^backColor! !

!CPScrollingPane methods !   
canSort
    "Private"

    ^canSort! !

!CPSubPane methods ! 
scrollTopCorner: aPoint
    "Private - Ignored by default."! !

!CPScrollingPane methods ! 
triggerDoubleClickEvent
		"Private"
    self event: #doubleClickSelect. " OBSOLETE "
    self triggerEvent: #doubleClickSelect: with: self selectedItem.! !

!CPScrollingPane methods !  
updateHorizontalSlider
    "Private"

    self updateHorizontalSliderTo: self topCorner x.! !

!CPSubPane methods !  
whileMouseStillDownDo: aBlock
	"Private - Evaluate aBlock while the mouse button is down.
		aBlock must take zero or one argument: the mouse location."

	| mouseUp moveSelectors upSelectors |

	moveSelectors := #(#button1Move: #button2Move:).
	upSelectors := #(#button1Up: #button1UpShift: #button2Up:).

	Notifier isButton1Down not & Notifier isButton2Down not ifTrue: [
		[(CurrentEvents
			detect: [:e | (e receiver == self) and: [upSelectors includes: e selector]]
			ifNone: [nil]) isNil
		] evaluateWithoutInterrupts ifTrue: [^self]].

	self
		captureMouseInput;
		startMouseMoveTimer.
	mouseUp := false.
	Notifier
		consumeInputUntil:
			[:event |
				(upSelectors includes: event selector)
					ifTrue: [
						#osiHack.
						"Sometimes the first argument is -1 @ -1 when it should
							be something else.  If it is then substitute the current
							cursor location."
						aBlock evaluateFor: (
							event arguments first = (-1 @ -1)
								ifTrue: [self cursorWindowPosition]
								ifFalse: [event arguments first copy]).
						mouseUp := true]
					ifFalse: [
						(moveSelectors includes: event selector)
							ifTrue: [
								self noSpin ifFalse: [aBlock evaluateFor: event arguments first copy].
								mouseUp := false]
							ifFalse: [event perform]].
			mouseUp].
	self
		stopMouseMoveTimer;
		clearMouseCapture.! !

!CPScrollingPane methods !   
updateRectangle
    "Private"

    rectangle := self rectangle.
    graphicsTool notNil
        ifTrue:
            [graphicsTool
                width: rectangle width;
                height: rectangle height].
    (rectangle height = 0) | (rectangle width = 0)
        ifFalse:
            [self reframe.
            ].! !

!CPCLBField methods !
printOn: aStream
    "Private"

    aStream nextPutAll: '(' , self header printString , ',' , self selectorString , ',' , self fieldWidthString , ',' , self justification , ')'.! !

!CPScrollingPane methods ! 
getClosestScrollPos: value
within: boundPoint
    "Private - answer a scrolling position that is as 'clean'
     as possible - if greater than one cell away already,
     cause a jump scroll by setting to the middle of the
     bound area"

    | newPos |
    (value >= boundPoint x) & (value <= boundPoint y)
        ifTrue: [^boundPoint x].
    (value = (boundPoint x - 1))
        ifTrue:
            [newPos := value.
            ]
        ifFalse:
            [(value = (boundPoint y + 1))
                ifTrue:
                    [newPos := boundPoint x + 1.
                    ]
                ifFalse:
                    [newPos := value - ((boundPoint y - boundPoint x) // 2).
                    ].
            ].
    ^newPos! !

!CPScrollingPane methods ! 
amountToScrollLeft
    "Private"

    ^self cellSize x! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPSubPane methods ! 
dragSourceCutDefault: dragSession
		"Private - perform default cut action if no handler is provided."
		"Ignored by default..."! !

!CPSubPane class methods !
defaultBackColor
    "Private"

	#osiHack.
    "In the ST/V 3.0 beta release 2, Color windowBackground
        returned an RGBColor and would cause a stack
        overflow... so return an IndexedColor instead."

    "^Color buttonFace asIndexedColor"
    ^Color buttonFace! !

!CPScrollingPane methods !   
cursor: aSymbol
    "Private"

    cursor := aSymbol! !

!CPCLBField methods !   
font: aFont
    "Private"

    font := aFont.
    self calculateCachedWidth! !

!CPScrollingPane class methods !
cellInset: aRectangleOrPoint

	cellInset := aRectangleOrPoint.
	self headerInset: nil.! !

!CPSubPane methods !  
noSpin: aBoolean
    "Enabled or disable the no spin option."

    self propertyAt: #noSpin put: (
        aBoolean = false ifTrue: [nil] ifFalse: [aBoolean]).
! !

!CPCLBField methods ! 
justificationString
    "Private"

    | string |
    string := self justification asString.
    string at: 1 put: (string at: 1) asUpperCase.
    ^string! !

!CPCLBField methods !  
setFont: aFont
	"Private"

	font isNil ifTrue: [font := aFont].
		"Cannot set the cached width here
			because the user may have resized
			the field and it should not be
			reset to its original size."
	"self calculateCachedWidth"! !

!CPSubPane methods !
cursorWindowPosition
    "Private - Answer the current position of the cursor
         in window coordinates."

    ^CursorManager new sense mapScreenToClient: self.! !

!CPScrollingPane methods !
showFocusInCell: aCell
    "Private"

    | point width |
    point := self pointForCell: aCell.
    width := self totalCells x * self cellSize x max: self rectangle width.
    self doGraphics: [self pen drawFocusRect: (point rightBottom: width @ (point y + self cellSize y))].! !

!CPScrollingPane methods !  
canReorder: aBoolean
   "Set whether columns can be reordered."

    canReorder := aBoolean! !

!CPScrollingPane methods !   
isDisabled: ignore
    "Private"

    ^false! !

!CPScrollingPane methods !  
totalLength
    "Private - Answer the height of the receiver's graphics medium."

    ^self fullExtent y! !

!CPScrollingPane methods !  
canReorder
    "Private"

    ^canReorder! !

!CPScrollingPane class methods !   
headerInset

	^headerInset ifNil: [
		headerInset := self defaultHeaderInset]! !

!CPScrollingPane methods ! 
defaultCanSort
    "Private"

    ^false! !

!Object methods !   
wbAttributeNamed: aSymbol
    "Answer the attribute of the receiver named <aSymbol>"
    #addedByOSI.
    ^self perform: aSymbol.! !

!CPScrollingPane methods ! 
visibleRectangle
    "Private"

    | extent |
    "overloaded for use within WindowBuilder"
    self inWindowBuilder
        ifTrue:
            [extent := self wbDisplayRectangle extent]
        ifFalse:
            [extent := self rectangle extent.
            ].
    ^0 @ 0 extent: extent! !

!CPScrollingPane methods !  
finalizeMoveOperation: dragDrop
    "Private - clean up after a drag & drop move operation"

    #obsoleteMethod.
    self
        contents:
            (self contents
            reject:
                [:elem |
                dragDrop items includes: elem]).! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPScrollingPane methods !  
doSetFocus
    "Private"

    self
        setFocus;
        showFocus! !

!CPScrollingPane methods !  
compatibleDragObjectDataFor: aDragObject
    "Private - Answer the compatible drag object data."

	| answer |
	self dragTargetFormats do: [ :eachFormat |
		(answer := aDragObject
			format: eachFormat
			ifAbsent: [ nil ]
		) notNil ifTrue: [
			eachFormat = 'object' ifFalse: [ ^answer ].
			(self isCompatibleObject: answer) ifTrue: [ ^answer ] ] ].
	^nil
! !

!CPScrollingPane methods !   
displayWith: aPen
inRect: aRect
clipRect: clipRect
	"Private - handle display event"

	| origin |
	"Out of WindowBuilder, this component will have a border that causes it to
	 display one pixel differently - we're emulating that here with the inset"
	rectangle := aRect leftTop extentFromLeftTop: aRect extent - 1.
	graphicsTool := aPen.
	self wbDisplayContext pen: aPen.
	aPen rectangle: aRect.
	origin := aRect leftTop + 1.
	GDILibrary
			offsetViewportOrgEx: graphicsTool handle
			x: origin x
			y: origin y
			oldPosition: nil.
	self wbDisplayContext viewPortOrigin: origin.
	self display.
	self wbDisplayContext viewPortOrigin: 0 @ 0.
	GDILibrary
			offsetViewportOrgEx: graphicsTool handle
			x: origin x negated
			y: origin y negated
		  oldPosition: nil.
	aPen
		foreColor: Color black;
		drawRectangle: aRect.
	tempClipRect := nil.! !

!CPCLBField methods !   
selector
    "Private"

    ^selector! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPScrollingPane methods !   
updateSelection
    "Private - Selection just changed. Do nothing by default"! !

!CPScrollingPane methods !   
cellForPoint: aPoint
    "Private"

    ^(aPoint + topCorner - self headerExtent max: 0 @ 0) // self cellSize + 1! !

!CPScrollingPane methods ! 
isPointInRowHeader: aPoint
    "Private"

    ^aPoint x between: 0 and: self headerExtent x! !

!CPScrollingPane methods !   
rightButtonScroll: point
        "Private - Do right button scrolling."
	^self basicRightButtonScroll: point! !

!CPScrollingPane methods !   
hideFocus
    "Private - Do Nothing"! !

!CPScrollingPane methods !
clearWBDisplayContext
	"Private - Discard the reciever's WBDisplayContext."

	wbDisplayContext := nil.! !

!CPSubPane methods !  
dragTargetFormatsDefault
        "Private - answer the formats of drag objects that the receiver will accept."
    ^#( 'string' )! !

!CPScrollingPane methods !  
dragScrolls
    "Private"

    ^true! !

!CPSubPane methods !
reframe
    "Private"! !

!CPScrollingPane methods !   
gettingFocus
    "Private"

    self doSetFocus.
    super gettingFocus.! !

!CPCLBField methods !  
fieldWidth: anInteger
    "Private - Set the field width for this field, in characters"

    fieldWidth := anInteger.! !

!CPSubPane methods !   
darkerColor
    "Private"

    ^Color black! !

!CPScrollingPane methods !   
updateVerticalSlider
    "Private - Update the vertical slider position."

    "Make the vertical scroll bar represent cell scrolling
        rather than pixel scrolling."

    | pos h |
                                        "added --> + self cellSize y - 1 // self cellSize y"
    (h := self scrollableRectangle height + self cellSize y - 1 // self cellSize y) = 0
        ifTrue:
            [pos := 1.
            ]
        ifFalse:
            [pos := self topCorner y // self cellSize y.
                "self topCorner y / cellSize y / (h / cellSize y / 32767) ceiling."
            ].
    UserLibrary
            setScrollPos: self asParameter
            bar: SbVert
            position: pos truncated
            redraw: true.! !

!CPScrollingPane methods !   
dragTargetDropDefault: dragSession
        "Private - provide default handling of drop if no handler
        is provided by inserting the item into the list."
    | addList index collection anObject |
    addList := OrderedCollection new.
    dragSession objects do: [ :each |
        (anObject := self compatibleDragObjectDataFor: each) notNil ifTrue: [
            ((self contents includes: anObject) and: [dragSession source ~~ self])
                ifFalse: [addList add: anObject]]].
    addList isEmpty ifTrue: [ ^self ].
    index := ((self cellForPoint: dragSession targetLocation) y min: self contents size
+ 1) max: 1.
    collection := self contents asOrderedCollection.
    addList
        reverseDo:
            [:each |
            collection add: each beforeIndex: index].
    dragSession source == self ifTrue: [
        self dragSourceSelection notNil ifTrue: [
            self dragSourceSelection: (
                self dragSourceSelection collect: [ :each |
                    each < index
                        ifTrue: [ each ]
                        ifFalse: [ each + addList size ] ] ) ] ].
    self contents: collection asOrderedCollection.
    self redraw.! !

!CPSubPane methods !   
font
    "Private"

    ^super font ifNil: [ self defaultFont ]! !

!CPCLBField methods !
justification: aSymbol
    "Private"

    justification := aSymbol! !

!CPSubPane class methods !
supportedEvents
    "Private"

    ^Set with: #getContents with: #getPopupMenu! !

!CPScrollingPane methods !
dragTargetFormatsDefault
        "Private - answer the formats of drag objects that the receiver will accept."
    ^#( 'object' )! !

!CPCLBField methods !   
name

    name isNil ifTrue: [ ^'' ].
    ^name! !

!CPSubPane methods ! 
isDragSourceInitiation: aPoint
		"Private - answer whether aPoint is sufficiently removed
		from the initial dragSourceLocation to indicate a drag initation
		and one of the mouse buttons are still down."
	^Notifier isButton1Down | Notifier isButton2Down
		and: [ super isDragSourceInitiation: aPoint ]! !

!Bitmap methods !   
wbDisplayExtentWith: aWBDisplayContext
	"Answer the pixel extent needed to fully display the receiver."

	^self extent! !

!CPSubPane methods !  
currentClipRect
    "Private"

    | clipbox |
    clipbox := WinRectangle new.
    self doGraphics: [
        (GDILibrary getClipBox: self pen handle rectangle: clipbox asParameter) ].
    clipbox := clipbox asRectangle.
    ^clipbox! !

!SPDisplayContext methods !  
font

	^font! !

!CPScrollingPane methods !   
dragSourceCutDefault: dragSession
		"Private - perform default cut action if no handler is provided."
		"Ignored by default..."
	| index indices |
	index := 0.
	(indices := self dragSourceSelection) ifNil: [ ^self ].
	self contents: (
		self contents reject: [ :each |
			indices includes: (
				index := index + 1 ) ] ).! !

!CPSubPane methods ! 
defaultDragDropObjects
    "Answer the list of items that should be
     passed during drag-drop"

    | dragObjects |
    #obsoleteMethod.
    (dragObjects := self getDefaultDragObjects) notNil
        ifTrue: [^dragObjects].
    self contents isNil
        ifTrue: [^nil].
    dragObjects := Array with: self contents.
    self renderAsObjects
        ifFalse:
            [dragObjects := dragObjects
                collect:
                    [:each |
                    each asString]].
    ^dragObjects! !

!CPScrollingPane methods !  
pointForCell: aCell
    "Private"

    ^(aCell - 1) * self cellSize - topCorner + self headerExtent! !

!CPSubPane methods ! 
supportsDragDropObjects
    "Does the receiver support receiving full
     objects in a drag/drop transfer"

    #obsoleteMethod.
    ^true! !

!CPSubPane methods !   
displayWith: aPen
inRect: inRect
clipRect: cr
    "Private"

    self displayWith: aPen inRect: inRect! !

!CPScrollingPane methods !  
defaultStyle
    "Private - Answer an Integer with appropriate styles in it."

    ^WsBorder | WsHscroll | WsVscroll | WsChild | WsVisible! !

!CPScrollingPane methods !
losingFocus
    "Private"

    self hideFocus.
    super losingFocus.! !

!CPCLBField methods ! 
selector: aSymbol
    "Private"

    selector := aSymbol! !

!CPScrollingPane class methods !
stringWidth: aString
using: aFont
    "Private"

    | width string |
    width := 0.
    string := ReadStream on: aString.
    [string atEnd]
        whileFalse:
            [width := width max: (aFont wbStringWidth: string nextLine).
            ].
    ^width! !

!SPDisplayContext methods !
clipRect

    ^clipRect ifNil: [self defaultClipRect]! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPScrollingPane methods ! 
isOkToChange
    "Private - answer whether it is OK to change the selection."

    ^(self hasActionForEvent: #aboutToChange)
        ifTrue: [^super isOkToChange]
        ifFalse: [(self event: #commitSelection) ~= false]! !

!Object methods !
wbDisplayExtentWith: aWBDisplayContext
	"Answer the pixel extent needed to fully display the receiver."

	#addedByOSI.
	^self printString wbDisplayExtentWith: aWBDisplayContext! !

!CPScrollingPane methods ! 
headerColor: color
    "Set the background color for the header."

    headerColor := color! !

!CPSubPane methods ! 
foreColor: aColor
	"Set the forecolor and force a repaint."

	super foreColor: aColor.
	self redraw.! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPSubPane methods !  
dragTargetFormats
        "Private - answer the formats of drag objects that the receiver will accept."
    ^super dragTargetFormats ifNil: [ self dragTargetFormatsDefault ].! !

!CPSubPane methods !   
reframeIfNeeded: aRect
    "Private"

    rectangle = aRect
        ifFalse:
            [rectangle := aRect.
            self reframe.
            ].
    rectangle := aRect.! !

!CPScrollingPane class methods ! 
defaultCellInset

	| left right |
	left := self fieldMargin // 2.
	right := self fieldMargin - left.
	^left @ 0 rightBottom: right @ 0! !

!CPSubPane methods !
losingFocus
    "Private"

    self triggerLosingFocus! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPSubPane class methods !   
constructEventsTriggered
    "Private - answer the set of events that instances of the
     receiver can trigger."

    ^super
        constructEventsTriggered addAll: #(#rightClicked);
        yourself! !

!CPCLBField methods !  
name: aString

    name := aString.! !

!CPSubPane methods !  
dragTargetDropDefault: dragSession
        "Private - provide default handling of drop if no handler
        is provided by inserting the item into the list."
	| formats |
	formats := self dragTargetFormats.
	dragSession objects do: [ :each |
		formats do: [ :eachFormat |
			(each hasFormat: eachFormat) ifTrue: [
				self contents: (each format: eachFormat).
				^self redraw ] ] ].
	^nil! !

!CPSubPane methods !   
middleColor
    "Private"

    ^Color gray! !

!CPScrollingPane methods !
inBounds: aCell
    "Private - answer whether the cell is within the existing
     number of cells"

    ^(aCell x >= 1) & (aCell y >= 1) & (aCell x <= self totalCells x) & (aCell y <= self totalCells y)! !

!CPScrollingPane methods !  
getBottomCell
    "Private - Answer the lower right visible cell"

    ^self getTopCell + self fullyVisibleCells - (1 @ 1)! !

!CPSubPane methods !  
deactivate
    "Private - The receiver has been deactivated."! !

!CPCLBField methods !
foreColor: aColorOrSelector
    "Private"

    foreColor := aColorOrSelector.! !

!SPDisplayContext methods !
viewPortOrigin: aPoint

	viewPortOrigin := aPoint.! !

!CPSubPane methods !   
renderAsObjects
    "Private - should the receiver deliver objects in a drag & drop
     transfer or the string representations of the objects"

    #obsoleteMethod.
    ^(self propertyAt: #renderAsObjects) ~~ nil! !

!CPCLBField methods !
fieldPixelWidth: anObject
    "Private - Set the field width for this field, in pixels
    (used for autofieldWidth)"

    cachedWidth := anObject! !

!CPScrollingPane methods !   
isPointInHeader: aPoint
    "Private"

    ^aPoint y between: self rect top and: (self rect top down: self headerExtent y)! !

!CPScrollingPane methods !
amountToScrollUp
    "Private"

    ^self cellSize y! !

!CPScrollingPane class methods !
defaultHeaderInset
	"
	self withAllSubclasses do: [:each | each headerInset: nil].
	"
	^self cellInset leftTop + (0@2) rightBottom:
		self cellInset rightBottom + (0@2)! !

!CPSubPane methods !  
contents
    "Private"

    ^nil! !

!CPSubPane methods !
dragSourceNeedsObjectDefault: dragSession
        "Private - provide default for requested drag items if no handler
        is provided by supplying the currently selected item."
    | obj dragDropObject data |
	(obj := self contents) ifNil: [ ^self ].
	dragDropObject := dragSession objectClass new
		object: obj;
		string: obj asString;
		yourself.

	data := [ obj asDate ] on: Error do: [ nil ].
	data notNil ifTrue: [ dragDropObject format: 'date' data: data ].
	data := [ obj asTime ] on: Error do: [ nil ].
	data notNil ifTrue: [ dragDropObject format: 'time' data: data ].
	data := [ obj asInteger ] on: Error do: [ nil ].
	data notNil ifTrue: [
		(data = 0 and: [
			obj isString and: [
				(obj trimBlanks beginsWith: '0') not ] ]
		) ifFalse: [
			dragDropObject format: 'integer' data: data ] ].

    dragSession objects: ( Array with: dragDropObject ).! !

!CPScrollingPane class methods ! 
fieldMargin

	^fieldMargin ifNil: [
		fieldMargin := self defaultFieldMargin]! !

!CPScrollingPane methods ! 
isReadOnly: ignore
    "Private"

    ^false! !

!CPScrollingPane class methods !
defaultFieldMargin

	"
	CPScrollingPane withAllSubclasses do: [:each | each fieldMargin: nil].
	"

	^9! !

!CPCLBField methods !  
header: aString
    "Private"

    header := aString! !

!CPSubPane methods !
triggerClickedEvent

    self event: #clicked. " OBSOLETE "
    self triggerEvent: #clicked: with: self selection.! !

!SPDisplayContext methods !   
viewPortOrigin

	^viewPortOrigin ifNil: [
		viewPortOrigin := 0 @ 0]! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPCLBField methods ! 
foreColor
    "Private"

    ^foreColor! !

!CPSubPane methods ! 
wmGetdlgcode: wparam
with: lparam
    "Private - process WM_GETDLGCODE message."

    ^DlgcWantarrows | DlgcWantchars! !

!CPScrollingPane methods !
dragTargetMultipleItem
        "Private - answer whether instances of the receiver can accept
        multiple-item transfers when drag-drop enabled."
    ^true! !

!CPScrollingPane methods !  
canResize: aBoolean
   "Set whether the user can dynamically resize the column widths."

    canResize := aBoolean! !

!CPSubPane methods !  
setDragDropObjects
    "Set the drag & drop objects. This is the default handler for
      the #needsDragDropObjects event."

    #obsoleteMethod.
    self setDragDropObjects: self defaultDragDropObjects! !

!CPCLBField methods !  
printSelector
	"Private"

	^printSelector! !

!CPCLBField methods !  
defaultJustification
    "Private"

    ^#left! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPSubPane methods ! 
wbDisplayContextClass
	"Answer a the window builder display context class for the receiver."

	#addedByOSI.
	^SPDisplayContext! !

!CPScrollingPane methods !   
wmHScroll: wordInteger
with: longInteger
    "Private - Handle horizontal scrolling."

    | type pos |
    type := wordInteger lowWord.
    type = SbLineup
        ifTrue: [self scrollHorizontal: self amountToScrollLeft].
    type = SbLinedown
        ifTrue: [self scrollHorizontal: self amountToScrollRight].
    type = SbPageup
        ifTrue: [self scrollHorizontal: self amountToPageLeft].
    type = SbPagedown
        ifTrue: [self scrollHorizontal: self amountToPageRight].
    (type = SbThumbposition) | (type = SbThumbtrack)
        ifTrue:
            [pos := wordInteger highWord roundTo: (self pixelCellWidth: 1).
            (self topCorner x - pos) abs > 0
                ifTrue:
                    [self scrollHorizontal: self topCorner x - pos.
                    self updateHorizontalSliderTo: pos.
                    ].
            ^nil].
    self updateHorizontalSlider.
    ^nil! !

!CPCLBField methods !  
fieldWidth
	"Private"

	^fieldWidth ifNil: [ self header size ]! !

!CPSubPane methods ! 
cpStyle
    "Private"

    ^self propertyAt: #cpStyle! !

!CPCLBField methods !  
initialize
    "Private"

    justification := self defaultJustification.
    "font := self defaultFont."! !

!CPSubPane methods !  
updateRectangle
    "Private"

    | aRect |
    super updateRectangle.
    aRect := self rectangle.
    (aRect height = 0) | (aRect width = 0)
        ifFalse:
            [self reframe.
            ].! !

!CPScrollingPane class methods !
stringSize: aString
    "Private - Answer a point representing
        the maximum # of characters in a line
        and the number of lines."

    | width string height |
    width := 0.
    height := 0.
    string := ReadStream on: aString.
    [string atEnd]
        whileFalse:
            [width := width max: string nextLine size.
            height := height + 1.
            ].
    ^width @ (height max: 1)! !

!CPCLBField methods !  
wbDisplayExtentWith: aWBDisplayContext
	"Answer the pixel extent needed to fully display the receiver."

	font notNil ifTrue: [aWBDisplayContext font: self font].
	aWBDisplayContext justification: self justification.
	^self header wbDisplayExtentWith: aWBDisplayContext! !

!CPCLBField methods !
printSelector: aSymbol
	"Private"

	printSelector := aSymbol! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPCLBField methods !  
selectorString
    "Private"

    selector isNil
        ifTrue: [^''].
    ^'#' , selector asString! !

!UndefinedObject methods !
osiIgnoredInitializerSource !

!CPCLBField methods !
calculateCachedWidth
    "Calculate and cache the width of the receiver in pixels based on the current fieldWidth (the max number of characters the receiver holds) using a quick-and-dirty algorithm: multiply it by the average character pixel width for this font and then increase by a fudge factor so that we can be reasonably sure it's wide enough.  The more accurate algorithm is too slow."

    self autoFieldWidth
        ifFalse:
            [cachedWidth := fieldWidth * self font width.
            cachedWidth := cachedWidth + (cachedWidth * 0.33 "fudge factor") truncated]! !

!CPCLBField methods !
font
    "Private"

    ^font ifNil: [ self defaultFont ]! !
 
UndefinedObject removeSelector: #osiIgnoredInitializerSource!
   
"======== Initializers"!

  
CPSystemBitmaps at: 'CPSteelPatternSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 108' )!
   
CPSystemBitmaps at: 'CPCheckBoxSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 101' )!
   
CPSystemBitmaps at: 'CPCheckBoxOnSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 102' )!
 
CPSystemBitmaps at: 'CPRadioButtonSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 106' )!

CPSystemBitmaps at: 'CPRadioButtonOnSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 107' )!
  
CPSystemBitmaps at: 'CPLittleUpArrowSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 105' )!
  
CPSystemBitmaps at: 'CPLittleDownArrowSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 104' )!

CPSystemBitmaps at: 'CPRadioButtonOnRedSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 120' )!
   
CPSystemBitmaps at: 'CPRadioButtonOnYellowSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 125' )!

CPSystemBitmaps at: 'CPRadioButtonOnBlackSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 123' )!
 
CPSystemBitmaps at: 'CPRadioButtonOnBlueSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 122' )!
  
CPSystemBitmaps at: 'CPRadioButtonOnGreenSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 121' )!
 
CPSystemBitmaps at: 'CPRadioButtonOnCyanSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 127' )!
  
CPSystemBitmaps at: 'CPRadioButtonOnMagentaSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 126' )!
   
CPSystemBitmaps at: 'CPRadioButtonOnWhiteSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 124' )!
 
CPSystemBitmaps at: 'CPCheckBoxOnRedCheckSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 130' )!
 
CPSystemBitmaps at: 'CPCheckBoxOnGreenCheckSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 131' )!
   
CPSystemBitmaps at: 'CPCheckBoxOnBlueCheckSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 132' )!

CPSystemBitmaps at: 'CPCheckBoxOnBlackCheckSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 133' )!
   
CPSystemBitmaps at: 'CPCheckBoxOnWhiteCheckSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 134' )!
   
CPSystemBitmaps at: 'CPCheckBoxOnYellowCheckSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 135' )!
  
CPSystemBitmaps at: 'CPCheckBoxOnCyanCheckSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 137' )!

CPSystemBitmaps at: 'CPCheckBoxOnMagentaCheckSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 136' )!
 
CPSystemBitmaps at: 'CPCheckBoxOnRedCrossSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 140' )!
 
CPSystemBitmaps at: 'CPCheckBoxOnGreenCrossSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 141' )!
   
CPSystemBitmaps at: 'CPCheckBoxOnBlueCrossSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 142' )!

CPSystemBitmaps at: 'CPCheckBoxOnBlackCrossSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 143' )!
   
CPSystemBitmaps at: 'CPCheckBoxOnWhiteCrossSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 144' )!
   
CPSystemBitmaps at: 'CPCheckBoxOnYellowCrossSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 145' )!
  
CPSystemBitmaps at: 'CPCheckBoxOnCyanCrossSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 147' )!

CPSystemBitmaps at: 'CPCheckBoxOnMagentaCrossSysBitmap' put: (
    Compiler evaluate:
'WBBitmapClass
    fromModule: ''sp31sysw.dll''
    id: 146' )!