"3.1.1.0"
!  

CPSubPane subclass: #CPSpinEditor
  instanceVariableNames: 
    ' fields currentField '
  classVariableNames: ''
  poolDictionaries: 
    ' CharacterConstants CPSystemBitmaps OperatingSystemConstants VirtualKeyConstants '! 

CPSpinEditor subclass: #CPSpinButton
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: 
    ' VirtualKeyConstants '! 

CPSpinEditor subclass: #CPNumericEditor
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: 
    ' CharacterConstants '!   

EntryField subclass: #CPEntryField
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: 
    ' CharacterConstants OperatingSystemConstants VirtualKeyConstants '!   

WBObject subclass: #SpinField
  instanceVariableNames: 
    ' rect width value inputState justification choices min max showLeadingZeros parent charactersTyped '
  classVariableNames: ''
  poolDictionaries: 
    ' OperatingSystemConstants '!  

CPSpinEditor subclass: #CPTimeEditor
  instanceVariableNames: 
    ' hourField minuteField meridianField separator format '
  classVariableNames: ''
  poolDictionaries: ''!

CPSpinEditor subclass: #CPDateEditor
  instanceVariableNames: 
    ' dayField monthField yearField separator format '
  classVariableNames: ''
  poolDictionaries: 
    ' CharacterConstants '!

!CPTimeEditor methods ! 
contents
    "Answer the selected time"

    | hours |
    hours := self hour.
    format == #hour24
        ifTrue:
            [hours = 24
                ifTrue:
                    [hours := 0.
                    ].
            ]
        ifFalse:
            [(meridianField value = 2)
                ifTrue:
                    [hours < 12
                        ifTrue:
                            [hours := hours + 12.
                            ].
                    ]
                ifFalse:
                    [hours = 12
                        ifTrue: [hours := 0].
                    ].
            ].
    ^Time
            hours: hours
            minutes: self minute
            seconds: 0.! !

!CPDateEditor methods !  
incrementYear
    "Private"

    (yearField value = 99)
        ifTrue:
            [yearField value: 0.
            ]
        ifFalse:
            [yearField increment.
            ].! !

!CPTimeEditor methods !   
separator: aString
    "Set the separator used between the hour and minute"

    separator := aString.
    (fields after: hourField) value: aString.! !

!SpinField methods !   
valueString
    "Private"

    | string |
    (choices isNil or: [choices isEmpty])
        ifFalse:
            [string := (choices at: value) asString.
            ]
        ifTrue:
            [value isInteger
                ifTrue:
                    [inputState = #nothing
                        ifTrue: [^''].
                    self normalizeValue.
                    string := value asString.
                    self showLeadingZeros
                        ifTrue:
                            [string := ((String new: (width - string size max: 0)) atAllPut: $0) , string.
                            ].
                    (width >= 1) & (string size > width)
                        ifTrue:
                            [string := string copyFrom: (string size - width + 1) to: string size.
                            ].
                    ]
                ifFalse:
                    [string := value asString.
                    ].
            ].
    ^string! !

!CPTimeEditor methods !
separator
    "Answer the separator string (1 character long) used to separate the hour and minute fields."

    ^separator! !

!CPDateEditor methods !  
monthAsAbbrev
    "Set the month style to be text abbreviation"

    self propertyAt: #cpStyle put: #monthAsAbbrev.
    monthField
        justification: #center;
        choices: #('JAN' 'FEB' 'MAR' 'APR' 'MAY' 'JUN' 'JUL' 'AUG' 'SEP' 'OCT' 'NOV' 'DEC');
        width: 3! !

!CPNumericEditor methods !  
characterInput: aChar
    "Private"

    aChar = Bs
        ifTrue:
            [currentField backspace.
            self contents.
            self triggerEvents.
            ^self].
    (aChar ~= Tab and: [aChar asciiValue ~= 7 "BackTab" and: [aChar ~= Cr]])
        ifTrue:
            [currentField characterInput: aChar.
            self contents.
            self triggerEvents].
    ! !

!CPDateEditor methods !
separator
	"Answer the separator string (1 character long) used to separate the DMY fields."

    ^separator! !

!CPDateEditor methods ! 
day
    "Answer the current day"

    dayField value: (1 max: (dayField value min: self lastDayInMonth)).
    ^dayField value.! !

!CPTimeEditor methods !  
incrementMinute
    "Private"

    (minuteField value = 59)
        ifTrue:
            [minuteField value: 0.
            self incrementHour.
            ]
        ifFalse:
            [minuteField increment].! !

!CPTimeEditor methods ! 
increment
    "Private"

    (currentField == hourField)
        ifTrue:
            [self incrementHour]
        ifFalse:
            [(currentField == minuteField)
                ifTrue:
                    [self incrementMinute]
                ifFalse:
                    [meridianField increment.
                    ].
            ].
    self contents! !

!CPDateEditor methods !   
monthAsNumber
    "Set the month style to be numeric"

    self propertyAt: #cpStyle put: #monthAsNumber.
    monthField
        justification: #right;
        choices: nil;
        width: 2.! !

!CPSpinEditor methods !  
min: newValue
    "Set the minimum value the reciever"

    currentField min: newValue! !

!SpinField methods !  
parent: aCPSpinEditor
    "Private"

    parent := aCPSpinEditor! !

!CPDateEditor methods ! 
dragTargetFormatsDefault
        "Private - answer the formats of drag objects that the receiver will accept."
    ^#( 'date' )! !

!SpinField methods !  
backspace
    "Private"

    | newValue |
    self inEdit
        ifFalse: [^self].
    newValue := value asString.
    newValue := newValue copyFrom: 1 to: newValue size - 1.
    newValue = ''
        ifTrue:
            [inputState := #nothing.
            ^self value: 0].
    self value: newValue asInteger.! !

!CPDateEditor methods ! 
increment
    "Private"

    (currentField == dayField)
        ifTrue:
            [self incrementDay]
        ifFalse:
            [(currentField == monthField)
                ifTrue:
                    [self incrementMonth.
                    ]
                ifFalse:
                    [self incrementYear.
                    ].
            ].
    self contents.! !

!CPNumericEditor methods ! 
value
    "Answer the contents of the reciever"

    ^self contents! !

!CPSpinEditor methods !  
buttonWidth
    "Private"

    ^17! !

!CPSpinButton methods !   
justification: aSymbol
    "Private"

    currentField justification: aSymbol! !

!CPDateEditor methods !
decrementDay
    "Private"

    (dayField value = 1)
        ifTrue:
            [self decrementMonth.
            dayField value: self lastDayInMonth.
            ]
        ifFalse:
            [dayField decrement.
            ].! !

!CPSpinButton methods !
selectedItem
    "Answer the selected item"

    currentField choices isEmpty
        ifTrue: [^nil].
    ^currentField choices at: currentField value! !

!CPSpinEditor methods ! 
reframe
	"Private"

	| totalFixed totalVariable charWidth fieldRect x w widths |
	totalFixed := 0.
	charWidth := (self font stringExtent: '0') x.
	widths := Dictionary new.
	fields
		do:
			[:f |
			f width >= 1
				ifTrue:
					[f isStatic
						ifTrue:
							[w := (self font stringExtent: f value) x.
							]
						ifFalse:
							[f choices notNil
								ifTrue:
									[w := 0.
									f choices
										do:
											[:choice |
											w := w max: (self font stringExtent: choice) x].
									]
								ifFalse:
									[w := f width * charWidth.
									].
							].
					widths at: f put: w + 2.
					totalFixed := totalFixed + w + 2.
					].
			].
	fieldRect := self fieldRect.
	totalVariable := fieldRect width - totalFixed.
	x := fieldRect left.
	fields
		do:
			[:f |
			f width >= 1
				ifTrue:
					[f rect: ((x @ fieldRect top) extent: (widths at: f) @ fieldRect height).
					]
				ifFalse:
					[f rect: ((x @ fieldRect top) extent: (f width * totalVariable) rounded @ fieldRect height).
					].
			x := x + f rect width.
			].! !

!CPSpinEditor methods !  
max

    ^currentField max! !

!CPDateEditor methods !
dayLeadingZero
	"Answer a boolean - whether leading zeros are showed for days."

    ^dayField showLeadingZeros! !

!CPDateEditor methods !  
monthLeadingZero: aBoolean
    "Show the leading zero on a month or not"

    monthField showLeadingZeros: aBoolean! !

!CPSpinEditor methods !  
incrementRect
    "Private"

    | extent |
    extent := self extent.
    ^(extent x - self buttonWidth) @ 0 corner: extent x @ (extent y // 2 + 1)! !

!SpinField methods !  
displayAt: offset
with: pen
clipRect: cRect
    "Private"

    | startX v displayRect fore back region clip |
    (rect isNil or: [pen isNil])
        ifTrue: [^self].
    displayRect := (rect translateBy: offset) insetBy: (1 @ 0).
    startX := displayRect left.
    v := self valueString.
    justification isNil | (justification == #left)
        ifFalse:
            [justification == #right
                ifTrue:
                    [startX := displayRect right - (parent font stringExtent: v) x.
                    ]
                ifFalse:
                    [startX := displayRect center x - ((parent font stringExtent: v) x // 2).
                    ]].
    inputState == #focus
        ifTrue:
            [fore := parent backColor ifNil: [ Color windowBackground ].
            back := parent foreColor ifNil: [ Color windowText ].
            ]
        ifFalse:
            [back := parent backColor.
            fore := parent foreColor.
            ].
    clip := ((parent fieldRect translateBy: offset) expandBy: (1 @ 2)).
    cRect isNil
        ifFalse:
            [clip := cRect intersect: clip.
            ].
    region := pen setClipRect: clip.
    displayRect := displayRect leftTop - (1 @ 2) rightBottom: displayRect rightBottom + 1.
    pen
        foreColor: fore;
        backColor: back;
        fill: displayRect color: back;
        setTextAlign: TaTop;
        setBackMode: Transparent;
        displayText: v at: startX @ displayRect top.
    pen destroyRegion: region.! !

!SpinField methods ! 
justification
    "Private"

    ^justification! !

!SpinField methods ! 
max
    "Private"

    ^max! !

!CPSpinEditor methods !  
fields: listOfSpinFields
    "Private"

    fields := listOfSpinFields.
    currentField := fields first.! !

!CPDateEditor methods !   
decrement
    "Private"

    (currentField == dayField)
        ifTrue:
            [self decrementDay]
        ifFalse:
            [(currentField == monthField)
                ifTrue:
                    [self decrementMonth.
                    ]
                ifFalse:
                    [self decrementYear.
                    ].
            ].
    self contents.! !

!SpinField methods !   
normalizeValue
    "Private"

    max notNil
        ifTrue:
            [value > max
                ifTrue:
                    [value := max.
                    ].
            ].
    min notNil
        ifTrue:
            [value < min
                ifTrue:
                    [value := min.
                    ].
            ].! !

!SpinField methods !
width: anInteger
    "Private"

    width := anInteger! !

!SpinField methods !  
characterInput: aChar
    "Private"

    | int oldValue |
    parent disabled
        ifTrue: [^self].
    choices notNil
        ifTrue:
            [choices notEmpty
                ifFalse:
                    [(Smalltalk at: #Terminal) bell.
                    ^self
                    ].
            int := value.
            [int := int + 1.
                int > choices size
                    ifTrue: [int := 1].
                (((choices at: int) asString at: 1) asUpperCase = aChar asUpperCase) | (int = value)]
                whileFalse: [].
            self value: int.
            ]
        ifFalse:
            [aChar isDigit | (aChar = $-)
                ifFalse:
                    [(Smalltalk at: #Terminal) bell.
                    ]
                ifTrue:
                    [inputState == #editing
                        ifFalse:
                            [aChar = $-
                                ifTrue:
                                    [inputState := #editing.
                                    value := '-'.
                                    ]
                                ifFalse:
                                    [value := (String with: aChar) asInteger.
                                    inputState := #editing.
                                    ].
                            charactersTyped := 1.
                            ]
                        ifTrue:
                            [value := (value asString , (String with: aChar)) asInteger.
                            charactersTyped := charactersTyped + 1.
                            ].
                    oldValue := value.
                    self display.
                    (oldValue ~= value) | (charactersTyped = width)
                    | (max notNil and: [value * 10 > max])
                        ifTrue:
                            [self inputState: #focus.
                            self display.
                            parent shiftRight.
                            ].
                    ].
            ]! !

!CPSpinEditor methods !   
characterInput: aChar
    "Private"
    "Eliminate beeps for tabs, backtabs, and backspaces.
    Tabs have already been processed by keyboardInput: so no further work is necessary."

    aChar = Bs
        ifTrue:
            [currentField backspace.
            self contents.
            self triggerEvents.
            ^self].
    (aChar = Tab or: [aChar asciiValue = 7 "BackTab"])
        ifFalse:
            [currentField characterInput: aChar.
            currentField inEdit
                ifFalse:
                    [self contents.
                    self triggerEvents]]! !

!CPSpinButton methods !   
selection: anItem
    "Set selected item to anItem"

    anItem isInteger
        ifTrue:
            [currentField value: anItem]
        ifFalse:
            [currentField value: (currentField choices indexOf: anItem).
            ].! !

!CPSpinEditor methods ! 
button1Down: point
    "Private"

    | rect |
    self disabled
        ifTrue: [^self].
    (self subpaneButton1Down: point)
        ifFalse: [^self].
    fields
        do:
            [:f |
            f isStatic not & (f rect containsPoint: point)
                ifTrue:
                    [(f == currentField)
                        ifFalse:
                            [currentField inEdit ifTrue: [
                                self contents.
                                self triggerEvents].
                            currentField losingFocus.
                            ].
                    currentField := f.
                    ].
            ].
    self hasFocus & (currentField inputState == #focus) not
        ifTrue:
            [currentField gettingFocus.
            ].
    self setFocus.
    self
        doGraphics:
            [((rect := self decrementRect) containsPoint: point)
                ifTrue:
                    [self pen reverse: (self decrementRect insetBy: 1).
                    self buttonPushedInRect: self decrementRect method:
#decrement.
                    self pen reverse: (self decrementRect insetBy: 1)].
            ((rect := self incrementRect) containsPoint: point)
                ifTrue:
                    [self pen reverse: (self incrementRect insetBy: 1).
                    self buttonPushedInRect: self incrementRect method:
#increment.
                    self pen reverse: (self incrementRect insetBy: 1).
                    ]].
    self whileMouseStillDown: [:currentMousePosition | ].! !

!CPSpinEditor methods ! 
contents: newValue
    "Set the contents of the reciever"

    currentField value: newValue! !

!CPSpinButton methods !  
increment
    "Set the selection to the previous item in the list"

    ^super decrement! !

!CPSpinEditor methods ! 
decrement
    "Decrement the reciever"

    currentField decrement.! !

!CPNumericEditor methods !   
contents
    "Answer the contents of the reciever"

    | anInteger |
    (anInteger := super contents) = '-'
        ifTrue:
            [^(0
                min:
                    (currentField max isNil
                    ifTrue: [0]
                    ifFalse: [currentField max]))
                max:
                    (currentField min isNil
                    ifTrue: [0]
                    ifFalse: [currentField min])]
        ifFalse:
            [^anInteger].! !

!CPSpinEditor methods ! 
shiftLeft
    "Private"

    | field |
    (currentField == fields first) | ((fields
        select:
            [:eachField |
            eachField isStatic not]) size <= 1)
        ifTrue: [^self].
    field := currentField.
    [field := fields before: field.
        (field isStatic not) | (field == fields first)]
        whileFalse: [].
    field == currentField
        ifFalse:
            [currentField inEdit ifTrue: [
                self contents.
                self triggerEvents].
            currentField losingFocus.
            currentField := field.
            currentField gettingFocus.
            ].! !

!CPNumericEditor methods ! 
value: anInteger
    "Set the contents of the reciever"

    self contents: anInteger! !

!CPSpinEditor methods !
min

    ^currentField min! !

!SpinField methods !   
width
    "Private"

    ^width! !

!CPSpinButton methods !  
initialize
    "Private"

    super initialize.
    fields := OrderedCollection
        with:
            (currentField := SpinField
            new parent: self;
            width: 0.99;
            choices: #(); "choices: #('Monday' 'Tuesday' 'Wednesday' 'Thursday' 'Friday');"
            justification: #center).! !

!CPSpinButton methods !  
selection
    "Answer the index of the selected item"

    ^currentField value! !

!CPDateEditor methods !   
characterInput: aChar
    "Private"
    "Eliminate beeps for tabs, backtabs, and backspaces.
    Tabs have already been processed by keyboardInput: so no further work is necessary."

    aChar = Bs
        ifTrue:
            [currentField backspace.
            self contents.
            self triggerEvents.
            ^self].
    (aChar = Tab or: [aChar asciiValue = 7 "BackTab"])
        ifFalse:
            [currentField characterInput: aChar.
            (fields
                select:
                    [:f |
                    f inEdit]) isEmpty
                ifTrue:
                    [self contents.
                    self triggerEvents]]! !

!CPSpinButton methods !
isCompatible: anObject
    "Is <anObject> compatible with the receiver"

	#obsoleteMethod.
    ^anObject isString! !

!CPSpinButton methods !   
rightJustified
    "Use right justification"

    currentField justification: #right! !

!CPSpinEditor class methods !   
constructEventsTriggered
    "Private - answer the set of events that instances of the
     receiver can trigger."

    ^super
        constructEventsTriggered addAll: #(#valueChanged:);
        yourself! !

!CPTimeEditor methods !   
leadingZero

    ^hourField showLeadingZeros! !

!CPSpinButton methods !  
dragSourceNeedsObjectDefault: dragSession
        "Private - provide default for requested drag items if no handler
        is provided by supplying the currently selected item."
    | dragDropObject |
	(dragDropObject := dragSession objectClass new)
		object: self selectedItem;
		string: dragDropObject object asString.
	dragDropObject object isNil ifTrue: [ ^self ].
    dragSession objects: ( Array with: dragDropObject ).! !

!CPTimeEditor methods !  
leadingZero: aBoolean
    "Show the leading zero or not"

    hourField showLeadingZeros: aBoolean! !

!CPDateEditor methods !   
contents
    "Answer the selected date"

    | year century cutoff |
    year := yearField value.
    self century
        ifFalse:
            [year < 100
                ifTrue:
                    [century := Date today year // 100 * 100.
                    cutoff := Date today year \\ 100 - 40 "Adjust to change the cutoff".
                    cutoff < 0
                        ifTrue: [cutoff := cutoff + 100].
                    year < cutoff
                        ifTrue: [year := year + century + 100]
                        ifFalse: [year := year + century].
                    ].
            ].
    ^Date
            newDay: self day
            month: (Date nameOfMonth: self month)
            year: year! !

!CPSpinButton methods !  
justification
    "Private"

    ^currentField justification! !

!CPSpinEditor methods ! 
increment
    "Increment the reciever"

    currentField increment! !

!CPDateEditor methods !   
dayLeadingZero: aBoolean
    "Show the leading zero on a day or not"

    dayField showLeadingZeros: aBoolean.! !

!CPNumericEditor methods !
isCompatible: anObject
    "Is <anObject> compatible with the receiver"

	#obsoleteMethod.
    ^anObject respondsTo: #asInteger! !

!CPSpinEditor methods ! 
buttonPushedInRect: inRect
method: methodToSend
    "Private"

    | startTime doneOne |
    startTime := Time millisecondClockValue.
    doneOne := false.
    self
        whileMouseStillDownPrim: [:currentMousePosition |
            (doneOne not | (Time millisecondClockValue > (startTime + 300))) & (inRect containsPoint: self mouseLocation)
                ifTrue:
                    [self
						perform: methodToSend;
						clearMouseCapture;
						triggerEvents;
						captureMouseInput.
				Smalltalk platformIsOS2 ifTrue: [ self redraw ].
                    doneOne := true.
                    ].
            ].! !

!SpinField methods !  
gettingFocus
    "Private"

    self inputState: #focus.
    self display.! !

!SpinField methods ! 
justification: aSymbol
    "Private"

    justification := aSymbol! !

!SpinField methods !  
losingFocus
    "Private"

    self inputState: #normal.
    self display.! !

!CPDateEditor methods !  
century
    "Private"

    ^yearField width = 4! !

!CPTimeEditor methods !  
format: aSymbol
    "Set the format of the field. Valid values are #hour12 and #hour24"

    format := aSymbol.
    format == #hour24
        ifTrue:
            [fields remove: meridianField ifAbsent: [nil].
            ]
        ifFalse:
            [(fields includes: meridianField)
                ifFalse:
                    [fields add: meridianField.
                    ].
            ].
    self isHandleOk
        ifTrue:
            [self reframe.
            self invalidateRect: nil.
            ].! !

!SpinField methods ! 
rect: aRect
    "Private"

    rect := aRect! !

!CPTimeEditor methods ! 
contents: anObject
    "Set the selected time to newTime"

    | hours newTime |
    [ newTime := anObject asTime ] on: Error do: [ ^self ].
    (self contents = newTime or: [newTime isNil])
        ifTrue: [^self].
    hours := newTime hours.
    format == #hour24
        ifTrue:
            [hours = 0
                ifTrue:
                    [hours := 24.
                    ].
            ]
        ifFalse:
            [(hours >= 12)
                ifTrue:
                    [meridianField value: 2.
                    (hours > 12)
                        ifTrue:
                            [hours := hours - 12.
                            ].
                    ]
                ifFalse:
                    [meridianField value: 1.
                    (hours = 0)
                        ifTrue:
                            [hours := 12.
                            ].
                    ].
            ].
    hourField value: hours.
    minuteField value: newTime minutes.! !

!CPSpinButton methods !  
event: theEvent
    "Private"

    theEvent == #valueChanged
        ifTrue: [^self triggerEvents].
    ^super event: theEvent! !

!CPSpinEditor methods ! 
keyboardInput: aKeyboardInputEvent
        "Private - keyboard input was received."
    | virtualKey changed |

    changed := false.
	aKeyboardInputEvent character isNil ifTrue: [
	    virtualKey := aKeyboardInputEvent virtualKey.
	    virtualKey = VkLeft
	        ifTrue: [^self shiftLeft].
	    virtualKey = VkRight
	        ifTrue: [^self shiftRight].
	    virtualKey = VkUp
	        ifTrue:
	            [self increment.
	            changed := true].
	    virtualKey = VkDown
	        ifTrue:
	            [self decrement.
	            changed := true].
	    (virtualKey = VkHome) & currentField min notNil
	        ifTrue:
	            [currentField
	                value: currentField min;
	                display.
	            changed := true.
	            ].
	    (virtualKey = VkEnd) & currentField max notNil
	        ifTrue:
	            [currentField
	                value: currentField max;
	                display.
	            changed := true.
	            ].
	].
    changed
        ifTrue: [ self triggerEvents ]
        ifFalse: [ super keyboardInput: aKeyboardInputEvent ].! !

!SpinField methods ! 
isStatic
    "Private"

    ^inputState == #static.! !

!SpinField methods ! 
decrement
    "Private"

    | newValue |
    newValue := value.
    choices notNil
        ifTrue:
            [newValue := newValue - 1.
            newValue < 1
                ifTrue:
                    [newValue := choices size.
                    ].
            ]
        ifFalse:
            [(min isNil or: [newValue > min])
                ifTrue:
                    [newValue := newValue - 1.
                    ].
            ].
    self value: newValue! !

!CPDateEditor methods ! 
isCompatible: anObject
    "Is <anObject> compatible with the receiver"

	#obsoleteMethod.
    ^anObject respondsTo: #asDate! !

!CPTimeEditor methods !
dragTargetFormatsDefault
        "Private - answer the formats of drag objects that the receiver will accept."
    ^#( 'time' )! !

!SpinField methods !  
increment
    "Private"

    | newValue |
    newValue := value.
    choices notNil
        ifTrue:
            [newValue := newValue + 1.
            newValue > choices size
                ifTrue:
                    [newValue := 1.
                    ].
            ]
        ifFalse:
            [(max isNil or: [newValue < max])
                ifTrue:
                    [newValue := newValue + 1.
                    ].
            ].
    self value: newValue! !

!CPDateEditor methods ! 
month
    "Answer the current month"

    monthField value: ((monthField value max: 1) min: 12).
    ^monthField value! !

!CPDateEditor methods !  
monthLeadingZero
	"Answer a boolean - whether leading zeros are showed for months."

    ^monthField showLeadingZeros! !

!CPTimeEditor methods !
hour
    "Answer the selected hour"

    format == #hour12
        ifTrue:
            [hourField value: ((hourField value max: 1) min: 12).
            ]
        ifFalse:
            [hourField value: ((hourField value max: 1) min: 24).
            ].
    ^hourField value! !

!SpinField methods !
min: anInteger1
max: anInteger2
    "Private"

    min := anInteger1.
    max := anInteger2.! !

!CPDateEditor methods !   
lastDayInMonth
    "Private"

    ^Date daysInMonth: (Date nameOfMonth: self month) forYear: yearField value! !

!CPSpinEditor methods ! 
fieldRect
    "Private"

    ^(0 @ 0 extent: (self extent x - self buttonWidth) @ (self extent y + 1)) insetBy: 4 @ 6! !

!CPSpinEditor methods !
valueChanged
    "Private"! !

!SpinField methods !
rect
    "Private"

    ^rect! !

!CPSpinEditor methods !
gettingFocus
    "Private"

    self disabled
        ifTrue: [^self].
    currentField gettingFocus.
    super gettingFocus.! !

!CPSpinEditor methods ! 
initialize
    "Private"

    super initialize.
    fields := OrderedCollection new.! !

!SpinField methods !   
min
    "Private"

    ^min! !

!SpinField methods ! 
min: anInteger
    "Private"

    min := anInteger! !

!CPNumericEditor methods !
dragTargetFormatsDefault
        "Private - answer the formats of drag objects that the receiver will accept."
    ^#( 'integer' )! !

!CPNumericEditor methods ! 
contents: anObject
    "Set the contents of the reciever"

    | newValue |
    [ newValue := anObject asInteger ] on: Error do: [ ^self ].
    ^super contents: newValue! !

!SpinField methods ! 
value: aValue
    "Private"

    (value = aValue)
        ifTrue: [^self].
    value := aValue.
    aValue isInteger
        ifFalse:
            [inputState := #static.
            width := aValue size.
            ].
    self display.! !

!SpinField methods !
showLeadingZeros
    "Private"

    ^showLeadingZeros = true! !

!SpinField methods !
choices
    "Private"

    ^choices! !

!CPSpinEditor methods !  
contents
    "Answer the contents of the reciever"

    ^currentField value.! !

!CPSpinEditor methods ! 
displayWith: pen
inRect: inRect
clipRect: cRect
    "Private"

    | incRect decRect aBitmap rect |
    rect := self rect translateBy: inRect leftTop.
    incRect := self incrementRect translateBy: inRect leftTop.
    decRect := self decrementRect translateBy: inRect leftTop.
    pen
        fill: rect color: self backColor;
        foreColor: self middleColor;
        drawRectangle: rect.
    rect := rect leftTop extent: self extent - ((incRect width - 1) @ 0).
    pen
        drawRectangle: rect;
        draw3DRect: rect
            depth: 1
            style: #in;
        fill: incRect color: self middleColor;
        fill: decRect color: self middleColor;
        draw3DRect: incRect
            depth: 1
            style: #out;
        draw3DRect: decRect
            depth: 1
            style: #out;
        backColor: self middleColor;
        foreColor: self foreColor.
    "Added test whether we're drawing within WB or not to
      determine whether to draw the fields before or after the bitmaps.  It turns out
      that drawing them before caused bitmap display problems in dialogs (?!!)"
    self inWindowBuilder
        ifTrue:
            [fields
                do:
                    [:field |
                    field
                            displayAt: rect leftTop
                            with: pen
                            clipRect: cRect].
            ].
    aBitmap := CPLittleUpArrowSysBitmap.
    pen
            copyBitmap: aBitmap
            from: aBitmap boundingBox
            at: incRect leftTop + (incRect extent - aBitmap extent // 2)
            rule: Srcand.
    aBitmap := CPLittleDownArrowSysBitmap.
    pen
            copyBitmap: aBitmap
            from: aBitmap boundingBox
            at: decRect leftTop + (decRect extent - aBitmap extent // 2)
            rule: Srcand.
    self inWindowBuilder
        ifFalse:
            [fields
                do:
                    [:field |
                    field
                            displayAt: rect leftTop
                            with: pen
                            clipRect: cRect].
            ].! !

!SpinField methods !  
inputState
    "Private"

    ^inputState! !

!CPSpinButton methods !
contents
    "Answer the contents of the reciever"

    ^currentField choices! !

!CPSpinButton methods !
triggerEvents
    "Private"

    self event: #select. " OBSOLETE "
    self triggerEvent: #select: with: self selectedItem! !

!CPSpinButton methods !  
contents: listOfStrings
    "Set the contents of the reciever"

    currentField choices: listOfStrings! !

!CPDateEditor methods !  
format
    "Answer the format string: one of #mdy, #dmy, or #ymd."

    ^format! !

!SpinField methods ! 
inputState: aSymbol
    "Private"

    inputState := aSymbol.
    (inputState ~= #editing) & (value = '-')
        ifTrue: [self value: 0].! !

!CPDateEditor methods !
incrementMonth
    "Private"

    (monthField value = 12)
        ifTrue:
            [monthField value: 1.
            self incrementYear.
            ]
        ifFalse:
            [monthField increment].! !

!CPSpinEditor class methods !   
supportedEvents
    "Private - Answer the events supported by this subpane."

    ^super
        supportedEvents add: #valueChanged;
        yourself! !

!CPTimeEditor methods !  
minute
    "Answer the selected minute"

    minuteField value: ((minuteField value max: 0) min: 59).
    ^minuteField value! !

!CPTimeEditor methods !
pmString: p
    "Set the PM designation strings"

	self amString: self amString pmString: p.! !

!CPSpinEditor methods ! 
triggerEvents
    "Private"

    self event: #valueChanged. " OBSOLETE "
    self triggerEvent: #valueChanged: with: self contents! !

!CPSpinButton class methods !
supportedEvents
    "Private - Answer the events supported by this subpane."

    ^super
        supportedEvents remove: #valueChanged;
        add: #select;
        yourself! !

!CPTimeEditor methods !
amString: a
pmString: p
    "Set the AM and PM designation strings"

    meridianField
        choices: (Array with: a with: p);
        width: (a size max: p size).! !

!SpinField methods !
value
    "Private"

    ^value! !

!CPTimeEditor methods !  
initialize
    "Private"

    super initialize.
    hourField := SpinField
        new parent: self;
        width: 2;
        justification: #right;
        value: 1.
    minuteField := SpinField
        new parent: self;
        width: 2;
        showLeadingZeros: true;
        justification: #right;
        value: 1.
    meridianField := SpinField
        new parent: self;
        width: 2;
        choices: #('AM' 'PM');
        justification: #center.
    separator := ':'.
    fields := OrderedCollection
        new add: hourField;
        add:
            (SpinField
            new parent: self;
            value: separator;
            justification: #center);
        add: minuteField;
        add:
            (SpinField
            new parent: self;
            value: ' ');
        add: meridianField;
        yourself.
    currentField := hourField.
    format := #hour12.
    self contents: Time now.! !

!CPSpinButton methods !   
decrement
    "Set the selection to the next item in the list"

    ^super increment! !

!CPTimeEditor methods ! 
decrement
    "Private"

    (currentField == hourField)
        ifTrue:
            [self decrementHour]
        ifFalse:
            [(currentField == minuteField)
                ifTrue:
                    [self decrementMinute]
                ifFalse:
                    [meridianField decrement.
                    ].
            ].
    self contents! !

!CPTimeEditor methods !   
incrementHour
    "Private"

    format == #hour24
        ifTrue:
            [(self hour = 24)
                ifTrue: [^hourField value: 1].
            hourField increment.
            ]
        ifFalse:
            [(self hour = 12)
                ifTrue: [^hourField value: 1].
            (self hour = 11)
                ifTrue:
                    [hourField value: 12.
                    meridianField increment.
                    ]
                ifFalse:
                    [hourField increment].
            ].! !

!CPSpinButton methods !
cpStyle
    "Private"

    | styleDict |
    styleDict := Dictionary new.
    styleDict
        at: #left put: #leftJustified;
        at: #right put: #rightJustified;
        at: #center put: #centered.
    ^styleDict at: currentField justification! !

!CPTimeEditor methods !  
amString
    "Private"

    ^meridianField choices first! !

!CPSpinEditor methods ! 
button1DoubleClick: aPoint
    "Private"

    ^self button1Down: aPoint! !

!CPDateEditor methods !  
decrementYear
    "Private"

    (yearField value = 0)
        ifTrue:
            [yearField value: 99.
            ]
        ifFalse:
            [yearField decrement.
            ].! !

!CPEntryField methods !   
modified
    "This entire subclass was created to get around the
      automatic 'Save changes?' dialog that pops up when
      you attempt to close a window containing a modified
      EntryField.  You cannot use #clearTextModified, as that
      is only sent to TextEdit/TextPanes, NOT EntryFields."

    ^false! !

!SpinField methods !   
showLeadingZeros: aBoolean
    "Private"

    showLeadingZeros := aBoolean! !

!CPSpinButton methods !   
centered
    "Use center justification"

    currentField justification: #center! !

!CPSpinButton methods ! 
valueChanged
    "Private"

    self triggerEvents! !

!SpinField methods !  
max: anInteger
    "Private"

    max := anInteger! !

!CPSpinEditor methods !   
losingFocus
    "Private"

    currentField inEdit ifTrue: [
        self contents.
        self triggerEvents].
    currentField losingFocus.
    super losingFocus.! !

!CPTimeEditor methods !
pmString
    "Private"

    ^meridianField choices last! !

!CPTimeEditor methods !  
decrementHour
    "Private"

    format == #hour24
        ifTrue:
            [(self hour = 1)
                ifTrue: [^hourField value: 24].
            hourField decrement.
            ]
        ifFalse:
            [(self hour = 1)
                ifTrue: [^hourField value: 12].
            (self hour = 12)
                ifTrue:
                    [hourField value: 11.
                    meridianField decrement.
                    ]
                ifFalse:
                    [hourField decrement].
            ].! !

!CPDateEditor methods !
format: aSymbol
    "Set the format of the control. Valid values are #ymd and #dmy"

    format := aSymbol asLowerCase asSymbol.
    self addFields: format.
    self isHandleOk
        ifTrue:
            [self reframe.
            self invalidateRect: nil.
            ].! !

!SpinField methods !  
display
    "Private"

    parent isHandleOk ifFalse: [ ^self ].
    parent
        doGraphics:
            [self
                    displayAt: 0 @ 0
                    with: parent pen
                    clipRect: nil].! !

!CPNumericEditor methods ! 
initialize
    "Private"

    super initialize.
    fields := OrderedCollection
        with:
            (currentField := SpinField
            new parent: self;
            width: 0.99;
            justification: #right;
            value: 0;
            min: nil max: nil).! !

!CPTimeEditor methods ! 
decrementMinute
    "Private"

    (minuteField value = 0)
        ifTrue:
            [minuteField value: 59.
            self decrementHour.
            ]
        ifFalse:
            [minuteField decrement].! !

!SpinField methods !
inEdit
    "Private"

    ^inputState == #editing! !

!CPDateEditor methods !
decrementMonth
    "Private"

    (monthField value = 1)
        ifTrue:
            [monthField value: 12.
            self decrementYear.
            ]
        ifFalse:
            [monthField decrement].! !

!CPTimeEditor methods ! 
isCompatible: anObject
    "Is <anObject> compatible with the receiver"

	#obsoleteMethod.
    ^anObject respondsTo: #asTime! !

!CPSpinButton methods !
keyboardInput: aKeyboardInputEvent
    "Private - keyboard input was received."

    | virtualKey changed |
    virtualKey := aKeyboardInputEvent virtualKey.
    changed := false.
    (virtualKey = HomeKey and: [self contents isEmpty not])
        ifTrue:
            [currentField
                value: 1;
                display.
            changed := true].
    (virtualKey = EndKey and: [self contents isEmpty not])
        ifTrue:
            [currentField
                value: self contents size;
                display.
            changed := true].
    changed
        ifTrue: [self triggerEvents]
        ifFalse: [super keyboardInput: aKeyboardInputEvent].
    ! !

!CPSpinEditor methods !   
shiftRight
    "Private"

    | field |
    (currentField == fields last) | ((fields
        select:
            [:eachField |
            eachField isStatic not]) size <= 1)
        ifTrue: [^self].
    field := currentField.
    [field := fields after: field.
        (field isStatic not) | (field == fields last)]
        whileFalse: [].
    field == currentField
        ifFalse:
            [currentField inEdit ifTrue: [
                self contents.
                self triggerEvents].
            currentField losingFocus.
            currentField := field.
            currentField gettingFocus.
            ].! !

!CPEntryField methods !  
setContents: aString

    "Prevent the textChanged message from
     happening when the contents is set and
     fix the case"

    self contents = aString ifTrue: [ ^self ].
    super contents: aString.
	self removeTextChangedEvent.! !

!CPDateEditor methods !   
initialize
    "Private"

    super initialize.
    dayField := SpinField
        new parent: self;
        width: 2;
        justification: #right;
        showLeadingZeros: true;
        max: 31;
        value: 1.
    monthField := SpinField
        new parent: self;
        width: 2;
        showLeadingZeros: true;
        justification: #right;
        max: 12;
        value: 1.
    yearField := SpinField
        new parent: self;
        width: 2;
        min: 0;
        justification: #right;
        value: 1.
    separator := '/'.
    self format: #mdy.
    self monthAsNumber.
    self contents: Date today.! !

!CPSpinButton class methods !  
constructEventsTriggered
    "Private - answer the set of events that instances of the
     receiver can trigger."

    ^super
        constructEventsTriggered remove: #valueChanged:;
        add: #select:;
        yourself! !

!CPSpinEditor methods !  
decrementRect
    "Private"

    | extent |
    extent := self extent.
    ^(extent x - self buttonWidth) @ (extent y // 2 - 1) corner: extent! !

!CPTimeEditor methods ! 
format

    ^format! !

!CPDateEditor methods !   
contents: anObject
    "Set the selected date to aDate"

    | aDate |
    [aDate := anObject asDate] on: Error do: [^self].
	aDate = self contents ifTrue: [^self].
    monthField value: aDate monthIndex.
    dayField value: aDate dayOfMonth.
    yearField value: aDate year.
	self isHandleOk ifTrue: [self triggerEvents].! !

!CPDateEditor methods ! 
separator: aString
    "Set the separator used between the day, month and year"

    separator := aString.
    fields notNil
        ifTrue:
            [fields
                do:
                    [:field |
                    field isStatic
                        ifTrue: [field value: aString]].
            ].! !

!CPTimeEditor methods !
amString: a
    "Set the AM designation strings"

	self amString: a pmString: self pmString.! !

!CPSpinEditor methods ! 
max: newValue
    "Set the maximum value the reciever"

    ^currentField max: newValue! !

!CPSpinButton methods !  
defaultDragDropObjects
    "Answer the list of items that should be
     passed during drag-drop"

    | dragObjects |
    #obsoleteMethod.
    (dragObjects := self getDefaultDragObjects) notNil
        ifTrue: [^dragObjects].
    dragObjects := Array with: self selectedItem.
    dragObjects first isNil
        ifTrue: [^nil].
    ^dragObjects! !

!SpinField methods !   
choices: aList
    "Private"

    choices := aList.
    value := 1.! !

!CPDateEditor methods ! 
incrementDay
    "Private"

    (dayField value = self lastDayInMonth)
        ifTrue:
            [dayField value: 1.
            self incrementMonth.
            ]
        ifFalse:
            [dayField increment.
            ].! !

!CPSpinButton methods !
leftJustified
    "Use left justification"

    currentField justification: #left! !

!CPDateEditor methods !
century: aBoolean
    "Show the century or not"

    yearField
        width:
            (aBoolean
            ifTrue: [4]
            ifFalse: [2]).! !

!CPDateEditor methods !   
monthAsText
    "Set the month style to be unabbreviated text"

    self propertyAt: #cpStyle put: #monthAsText.
    monthField
        justification: #center;
        choices: #('January' 'February' 'March' 'April' 'May' 'June' 'July' 'August' 'September' 'October' 'November' 'December');
        width: 9! !

!CPDateEditor methods !  
addFields: aSymbol
    "Private"

    | editFields |
    aSymbol == #dmy
        ifTrue:
            [editFields := Array
                    with: dayField
                    with: monthField
                    with: yearField.
            ]
        ifFalse:
            [aSymbol == #mdy
                ifTrue:
                    [editFields := Array
                            with: monthField
                            with: dayField
                            with: yearField.
                    ]
                ifFalse:
                    [editFields := Array
                            with: yearField
                            with: monthField
                            with: dayField.
                    ].
            ].
    fields := OrderedCollection
        new add: (editFields at: 1);
        add:
            (SpinField
            new parent: self;
            value: separator);
        add: (editFields at: 2);
        add:
            (SpinField
            new parent: self;
            value: separator);
        add: (editFields at: 3);
        yourself.
    currentField := fields first.! !
  
UndefinedObject removeSelector: #osiIgnoredInitializerSource!
   
"======== Initializers"!